/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    :   adslAtucChanPerfDataTable_access.c
 * Author       :   Subramani
 * Date         :   17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      :   Amazon
 * Block        :   ADSL-MIBs
 *
 * ===========================================================================
 * Contents: This file contains functions for:
 *                  1) Getting the data context pointer & loop context
 *                  pointer
 *                  2) User-defined data access functions (per column) for data
 *                  in table adslAtucChanPerfDataTable
 *
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */



/* ===========================================================================
 * Revision History:
 *  Subramani: Return types of get_adslAtucChanPerfValidIntervals,
 *  get_adslAtucChanPerfInvalidIntervals and
 *  get_adslAtucChanPerfPrev1DayMoniSecs are changed from long to int
 * $Log$
 * ===========================================================================
 */

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
*/

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "adslAtucChanPerfDataTable_access.h"
#ifdef STUB_IOCTL
#include "adslAtucChanPerfDataTable_enums.h"
#endif

/* column number definitions for table adslAtucChanPerfDataTable */
#include "adslAtucChanPerfDataTable_columns.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/

// *** Global variable definitions
static u_int32 long_ret;

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
*/

/** returns the first data point within the adslAtucChanPerfDataTable table
    data.

    Set the my_loop_context variable to the first data point structure
    of your choice (from which you can find the next one).  This could
    be anything from the first node in a linked list, to an integer
    pointer containing the beginning of an array variable.

    Set the my_data_context variable to something to be returned to
    you later that will provide you with the data to return in a given
    row.  This could be the same pointer as what my_loop_context is
    set to, or something different.

    The put_index_data variable contains a list of snmp variable
    bindings, one for each index in your table.  Set the values of
    each appropriately according to the data matching the first row
    and return the put_index_data variable at the end of the function.
*/
netsnmp_variable_list *
adslAtucChanPerfDataTable_get_first_data_point(void **my_loop_context,
                                               void **my_data_context,
                                               netsnmp_variable_list *
                                               put_index_data,
                                               netsnmp_iterator_info
                                               *mydata)
{

    int *My_Data_Context;
    My_Data_Context = SNMP_MALLOC_TYPEDEF(int);
    if (!My_Data_Context) {
        put_index_data = NULL;
        snmp_log(LOG_ERR, "Get-First: adslAtucChanPerDataTable: My_Data_Context malloc failed\n");
        return put_index_data;
    }

    *My_Data_Context=IFTYPE_ADSL_FAST_INTERLEAVE;
    *my_data_context=My_Data_Context;

    put_index_data = adslTable_get_first_data_point(my_loop_context,
                                   my_data_context,
                                   put_index_data,
                                   mydata);

    SNMP_FREE(My_Data_Context);
    return put_index_data;
}

/** functionally the same as adslAtucChanPerfDataTable_get_first_data_point, but
   my_loop_context has already been set to a previous value and should
   be updated to the next in the list.  For example, if it was a
   linked list, you might want to cast it to your local data type and
   then return my_loop_context->next.  The my_data_context pointer
   should be set to something you need later and the indexes in
   put_index_data updated again. */
netsnmp_variable_list *
adslAtucChanPerfDataTable_get_next_data_point(void **my_loop_context,
                                              void **my_data_context,
                                              netsnmp_variable_list *
                                              put_index_data,
                                              netsnmp_iterator_info
                                              *mydata)
{

    int *My_Data_Context;
    My_Data_Context = SNMP_MALLOC_TYPEDEF(int);
    if (!My_Data_Context) {
        put_index_data = NULL;
        snmp_log(LOG_ERR, "Get-Next: adslAtucChanPerDataTable: My_Data_Context malloc failed\n");
        return put_index_data;
    }
    *My_Data_Context=IFTYPE_ADSL_FAST_INTERLEAVE;
    *my_data_context=My_Data_Context;

     put_index_data = adslTable_get_next_data_point(my_loop_context,
                                   my_data_context,
                                   put_index_data,
                                   mydata);

    SNMP_FREE(My_Data_Context);
    return put_index_data;
}


/*
 * User-defined data access functions (per column) for data in table
    adslAtucChanPerfDataTable
 */
/*
 * NOTE:
 * - these get_ routines MUST return data that will not be freed (ie,
 *   use static variables or persistent data).  It will be copied, if
 *   needed, immediately after the get_ routine has been called.
 * - these SET routines must copy the incoming data and can not take
 *   ownership of the memory passed in by the val pointer.
 */

#if defined(HAVE_OPTIMIZED_CODE)

u_int32  *
get_adslAtucChanBlksData(void *data_context, size_t * ret_len,
			unsigned int var)
{
  unsigned int flags = 0;
  struct atucChannelPerfDataEntry atucChannelPerfDataStruct;
  memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
  atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
  
  switch (var)  {

        case COLUMN_ADSLATUCCHANRECEIVEDBLKS:
	   flags = ATUC_CHAN_RECV_BLK_FLAG;
	   break;

        case COLUMN_ADSLATUCCHANTRANSMITTEDBLKS:
	   flags = ATUC_CHAN_TX_BLK_FLAG;
	   break;

        case COLUMN_ADSLATUCCHANCORRECTEDBLKS:
	   flags = ATUC_CHAN_CORR_BLK_FLAG;
	   break;

        case COLUMN_ADSLATUCCHANUNCORRECTBLKS:
	   flags = ATUC_CHAN_UNCORR_BLK_FLAG;
	   break;

     	default:
           DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
     	   return NULL;
  }

  SET_FLAG(&atucChannelPerfDataStruct.flags, flags);
#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
        (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags, flags) == 0)
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfDataTable: GET- %x CMV fail\n", flags));

    switch (flags)  {
	    
	case ATUC_CHAN_RECV_BLK_FLAG:
    	   long_ret = atucChannelPerfDataStruct.adslAtucChanReceivedBlks;
	   break;

	case ATUC_CHAN_TX_BLK_FLAG:
    	   long_ret = atucChannelPerfDataStruct.adslAtucChanTransmittedBlks;
	   break;

	case ATUC_CHAN_CORR_BLK_FLAG:
    	   long_ret = atucChannelPerfDataStruct.adslAtucChanCorrectedBlks;
	   break;

	case ATUC_CHAN_UNCORR_BLK_FLAG:
    	   long_ret = atucChannelPerfDataStruct.adslAtucChanUncorrectBlks;
	   break;
		
        default:
            DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
            return NULL;
    }
    
    CLR_FLAG(&atucChannelPerfDataStruct.flags, flags);
    *ret_len = sizeof(u_int32);
    return (u_int32 *) &long_ret;
}


int *
get_adslAtucChanPerfIntervalData(void *data_context, size_t * ret_len,
			unsigned int var)
{
  unsigned int flags = 0;
  struct atucChannelPerfDataEntry atucChannelPerfDataStruct;
  memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
  atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);

  switch (var) {

      case COLUMN_ADSLATUCCHANPERFVALIDINTERVALS:
	 flags = ATUC_CHAN_PERF_VALID_INTVL_FLAG;
	 break;
	 
      case COLUMN_ADSLATUCCHANPERFINVALIDINTERVALS:
	 flags = ATUC_CHAN_PERF_INVALID_INTVL_FLAG;
	 break;

      case COLUMN_ADSLATUCCHANPERFPREV1DAYMONISECS:
	 flags = ATUC_CHAN_PERF_PREV_1DAY_MONI_SEC_FLAG;
	 break;
	 
      default:
     	 DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
     	 return NULL;
 }
  
 SET_FLAG(&atucChannelPerfDataStruct.flags, flags);
#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
        (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags, flags) == 0)
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfDataTable: GET- %x CMV fail\n", flags));

    switch (flags)  {
	    
	case ATUC_CHAN_PERF_VALID_INTVL_FLAG:
    	   long_ret = atucChannelPerfDataStruct.adslAtucChanPerfValidIntervals;
	   break;

	case ATUC_CHAN_PERF_INVALID_INTVL_FLAG:
    	   long_ret = atucChannelPerfDataStruct.adslAtucChanPerfInvalidIntervals;
	   break;

	case ATUC_CHAN_PERF_PREV_1DAY_MONI_SEC_FLAG:
    	   long_ret = atucChannelPerfDataStruct.adslAtucChanPerfPrev1DayMoniSecs;
	   break;

        default:
     	    DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
            return NULL;
    }
    
    CLR_FLAG(&atucChannelPerfDataStruct.flags, flags);
    *ret_len = sizeof(int);
    return (int *) &long_ret;
}


u_int32  *
get_adslAtucChanPerfStatsData(void *data_context, size_t * ret_len,
			unsigned int var)
{
  unsigned int flags = 0;
  struct atucChannelPerfDataEntry atucChannelPerfDataStruct;
  memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
  atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);

  switch (var) {

      case COLUMN_ADSLATUCCHANPERFCURR15MINTIMEELAPSED:
	 flags = ATUC_CHAN_PERF_CURR_15MIN_TIME_ELAPSED_FLAG; 
         break;
	 
      case COLUMN_ADSLATUCCHANPERFCURR15MINRECEIVEDBLKS:
	 flags = ATUC_CHAN_PERF_CURR_15MIN_RECV_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATUCCHANPERFCURR15MINTRANSMITTEDBLKS:
	 flags = ATUC_CHAN_PERF_CURR_15MIN_TX_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATUCCHANPERFCURR15MINCORRECTEDBLKS:
	 flags = ATUC_CHAN_PERF_CURR_15MIN_CORR_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATUCCHANPERFCURR15MINUNCORRECTBLKS:
	 flags = ATUC_CHAN_PERF_CURR_15MIN_UNCORR_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATUCCHANPERFCURR1DAYTIMEELAPSED:
	 flags = ATUC_CHAN_PERF_CURR_1DAY_TIME_ELAPSED_FLAG;
	 break;
	  
      case COLUMN_ADSLATUCCHANPERFCURR1DAYRECEIVEDBLKS:
	 flags = ATUC_CHAN_PERF_CURR_1DAY_RECV_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATUCCHANPERFCURR1DAYTRANSMITTEDBLKS:
	 flags = ATUC_CHAN_PERF_CURR_1DAY_TX_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATUCCHANPERFCURR1DAYCORRECTEDBLKS:
	 flags = ATUC_CHAN_PERF_CURR_1DAY_CORR_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATUCCHANPERFCURR1DAYUNCORRECTBLKS:
	 flags = ATUC_CHAN_PERF_CURR_1DAY_UNCORR_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATUCCHANPERFPREV1DAYRECEIVEDBLKS:
	 flags = ATUC_CHAN_PERF_PREV_1DAY_RECV_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATUCCHANPERFPREV1DAYTRANSMITTEDBLKS:
	 flags = ATUC_CHAN_PERF_PREV_1DAY_TX_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATUCCHANPERFPREV1DAYCORRECTEDBLKS:
	 flags = ATUC_CHAN_PERF_PREV_1DAY_CORR_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATUCCHANPERFPREV1DAYUNCORRECTBLKS:
	 flags = ATUC_CHAN_PERF_PREV_1DAY_UNCORR_BLK_FLAG;
	 break;
	 
      default:
     	 DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
         return NULL;
     }

 SET_FLAG(&atucChannelPerfDataStruct.flags, flags);
#ifdef ENABLE_DRIVER_CALL
     adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
     get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
			         (void *) &atucChannelPerfDataStruct);
#endif
     if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags, flags) == 0)
            DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfDataTable: GET- %x CMV fail\n", flags));

     switch (flags)  {

	 case ATUC_CHAN_PERF_CURR_15MIN_TIME_ELAPSED_FLAG:
	    long_ret = atucChannelPerfDataStruct.adslAtucChanPerfCurr15MinTimeElapsed;		 
            break;
	 
	 case ATUC_CHAN_PERF_CURR_15MIN_RECV_BLK_FLAG:
	    long_ret = atucChannelPerfDataStruct.adslAtucChanPerfCurr15MinReceivedBlks;
	    break;
	  
	 case ATUC_CHAN_PERF_CURR_15MIN_TX_BLK_FLAG:
	    long_ret = atucChannelPerfDataStruct.adslAtucChanPerfCurr15MinTransmittedBlks;
	    break;
	  
	 case ATUC_CHAN_PERF_CURR_15MIN_CORR_BLK_FLAG:
	    long_ret = atucChannelPerfDataStruct.adslAtucChanPerfCurr15MinCorrectedBlks;
	    break;
	  
	 case ATUC_CHAN_PERF_CURR_15MIN_UNCORR_BLK_FLAG:
	    long_ret = atucChannelPerfDataStruct.adslAtucChanPerfCurr15MinUncorrectBlks;
	    break;
	  
	 case ATUC_CHAN_PERF_CURR_1DAY_TIME_ELAPSED_FLAG:
	    long_ret = atucChannelPerfDataStruct.adslAtucChanPerfCurr1DayTimeElapsed;
	    break;
	  
	 case ATUC_CHAN_PERF_CURR_1DAY_RECV_BLK_FLAG:
	    long_ret = atucChannelPerfDataStruct.adslAtucChanPerfCurr1DayReceivedBlks;
	    break;
	  
	 case ATUC_CHAN_PERF_CURR_1DAY_TX_BLK_FLAG:
	    long_ret = atucChannelPerfDataStruct.adslAtucChanPerfCurr1DayTransmittedBlks;
	    break;
	  
	 case ATUC_CHAN_PERF_CURR_1DAY_CORR_BLK_FLAG:
	    long_ret = atucChannelPerfDataStruct.adslAtucChanPerfCurr1DayCorrectedBlks;
            break;
	  
	 case ATUC_CHAN_PERF_CURR_1DAY_UNCORR_BLK_FLAG:
	    long_ret = atucChannelPerfDataStruct.adslAtucChanPerfCurr1DayUncorrectBlks;
	    break;
	  
	 case ATUC_CHAN_PERF_PREV_1DAY_RECV_BLK_FLAG:
	   long_ret = atucChannelPerfDataStruct.adslAtucChanPerfPrev1DayReceivedBlks; 
	    break;
	  
	 case ATUC_CHAN_PERF_PREV_1DAY_TX_BLK_FLAG:
	    long_ret = atucChannelPerfDataStruct.adslAtucChanPerfPrev1DayTransmittedBlks;
	    break;
	  
	 case ATUC_CHAN_PERF_PREV_1DAY_CORR_BLK_FLAG:
            long_ret = atucChannelPerfDataStruct.adslAtucChanPerfPrev1DayCorrectedBlks;
	    break;
	  
	 case ATUC_CHAN_PERF_PREV_1DAY_UNCORR_BLK_FLAG:
	    long_ret = atucChannelPerfDataStruct.adslAtucChanPerfPrev1DayUncorrectBlks;
	    break;
	 
         default:
     	    DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
            return NULL;
     }
     
    CLR_FLAG(&atucChannelPerfDataStruct.flags, flags);
    *ret_len = sizeof(u_int32);
    return (u_int32 *) &long_ret;
}

#else

/** XXX: return a data pointer to the data for the adslAtucChanReceivedBlks
    column and set ret_len to its proper size in bytes. */

u_int32         *
get_adslAtucChanReceivedBlks(void *data_context, size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags, ATUC_CHAN_RECV_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
    (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
                        ATUC_CHAN_RECV_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfRecvBlk CMV fail\n"));
	
    CLR_FLAG(&atucChannelPerfDataStruct.flags, ATUC_CHAN_RECV_BLK_FLAG);
    long_ret=atucChannelPerfDataStruct.adslAtucChanReceivedBlks;
    *ret_len = sizeof(atucChannelPerfDataStruct.adslAtucChanReceivedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the adslAtucChanTransmittedBlks
    column and set
         ret_len to its proper size in bytes. */
u_int32         *
get_adslAtucChanTransmittedBlks(void *data_context, size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags, ATUC_CHAN_TX_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
    (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
                        ATUC_CHAN_TX_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfTxBlk CMV fail\n"));
    
    CLR_FLAG(&atucChannelPerfDataStruct.flags, ATUC_CHAN_TX_BLK_FLAG);
     long_ret=atucChannelPerfDataStruct.adslAtucChanTransmittedBlks;
    *ret_len = sizeof(atucChannelPerfDataStruct.adslAtucChanTransmittedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the adslAtucChanCorrectedBlks
    column and set ret_len to its proper size in bytes. */

u_int32         *
get_adslAtucChanCorrectedBlks(void *data_context, size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags, ATUC_CHAN_CORR_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
    (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
                        ATUC_CHAN_CORR_BLK_FLAG) == 0)
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfCorrBlk CMV fail\n"));

    CLR_FLAG(&atucChannelPerfDataStruct.flags, ATUC_CHAN_CORR_BLK_FLAG);
    long_ret=atucChannelPerfDataStruct.adslAtucChanCorrectedBlks;
    *ret_len = sizeof(atucChannelPerfDataStruct.adslAtucChanCorrectedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the adslAtucChanUncorrectBlks
    column and set ret_len to its proper size in bytes. */
u_int32         *
get_adslAtucChanUncorrectBlks(void *data_context, size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags, ATUC_CHAN_UNCORR_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
    (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
             ATUC_CHAN_UNCORR_BLK_FLAG) == 0)
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfUnCorrBlk CMV fail\n"));

    CLR_FLAG(&atucChannelPerfDataStruct.flags, ATUC_CHAN_UNCORR_BLK_FLAG);
    long_ret=atucChannelPerfDataStruct.adslAtucChanUncorrectBlks;
    *ret_len = sizeof(atucChannelPerfDataStruct.adslAtucChanUncorrectBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAtucChanPerfValidIntervals column and set
         ret_len to its proper size in bytes. */
int           *
get_adslAtucChanPerfValidIntervals(void *data_context, size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags, ATUC_CHAN_PERF_VALID_INTVL_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
    (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
                     ATUC_CHAN_PERF_VALID_INTVL_FLAG) == 0)
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfValidIntvl CMV fail\n"));

    CLR_FLAG(&atucChannelPerfDataStruct.flags, ATUC_CHAN_PERF_VALID_INTVL_FLAG);
     long_ret=atucChannelPerfDataStruct.adslAtucChanPerfValidIntervals;
    *ret_len = sizeof(atucChannelPerfDataStruct.adslAtucChanPerfValidIntervals);
    return (int *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAtucChanPerfInvalidIntervals column and set
         ret_len to its proper size in bytes. */
int           *
get_adslAtucChanPerfInvalidIntervals(void *data_context, size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags, ATUC_CHAN_PERF_INVALID_INTVL_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
    (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
                ATUC_CHAN_PERF_INVALID_INTVL_FLAG) == 0)
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfInvalidIntvl CMV fail\n"));

    CLR_FLAG(&atucChannelPerfDataStruct.flags, ATUC_CHAN_PERF_INVALID_INTVL_FLAG);
    long_ret=atucChannelPerfDataStruct.adslAtucChanPerfInvalidIntervals;
  *ret_len = sizeof(atucChannelPerfDataStruct.adslAtucChanPerfInvalidIntervals);
    return (int *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAtucChanPerfCurr15MinTimeElapsed column and set
         ret_len to its proper size in bytes. */
u_int32         *
get_adslAtucChanPerfCurr15MinTimeElapsed(void *data_context, size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_CURR_15MIN_TIME_ELAPSED_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
    (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
            ATUC_CHAN_PERF_CURR_15MIN_TIME_ELAPSED_FLAG) == 0)
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfCurr15Min CMV fail\n"));

    CLR_FLAG(&atucChannelPerfDataStruct.flags,
            ATUC_CHAN_PERF_CURR_15MIN_TIME_ELAPSED_FLAG);
     long_ret=atucChannelPerfDataStruct.adslAtucChanPerfCurr15MinTimeElapsed;
    *ret_len = sizeof(atucChannelPerfDataStruct.
                    adslAtucChanPerfCurr15MinTimeElapsed);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAtucChanPerfCurr15MinReceivedBlks column and set
         ret_len to its proper size in bytes. */
u_int32      *
get_adslAtucChanPerfCurr15MinReceivedBlks(void *data_context, size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags,
            ATUC_CHAN_PERF_CURR_15MIN_RECV_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
        (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
            ATUC_CHAN_PERF_CURR_15MIN_RECV_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfCurr15MinRecvBlk CMV fail\n"));

    CLR_FLAG(&atucChannelPerfDataStruct.flags,
            ATUC_CHAN_PERF_CURR_15MIN_RECV_BLK_FLAG);
    long_ret=atucChannelPerfDataStruct.adslAtucChanPerfCurr15MinReceivedBlks;
    *ret_len = sizeof(atucChannelPerfDataStruct.
                adslAtucChanPerfCurr15MinReceivedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAtucChanPerfCurr15MinTransmittedBlks column and set
         ret_len to its proper size in bytes. */
u_int32      *
get_adslAtucChanPerfCurr15MinTransmittedBlks(void *data_context,
    size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_CURR_15MIN_TX_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
        (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
            ATUC_CHAN_PERF_CURR_15MIN_TX_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfCurr15MinTxBlk CMV fail\n"));

    CLR_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_CURR_15MIN_TX_BLK_FLAG);
    long_ret=atucChannelPerfDataStruct.adslAtucChanPerfCurr15MinTransmittedBlks;
    *ret_len = sizeof(atucChannelPerfDataStruct.
            adslAtucChanPerfCurr15MinTransmittedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAtucChanPerfCurr15MinCorrectedBlks column and set
         ret_len to its proper size in bytes. */
u_int32      *
get_adslAtucChanPerfCurr15MinCorrectedBlks(void *data_context, size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_CURR_15MIN_CORR_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
        (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_CURR_15MIN_CORR_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfCurr15MinCorrBlk CMV fail\n"));

    CLR_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_CURR_15MIN_CORR_BLK_FLAG);
    long_ret=atucChannelPerfDataStruct.adslAtucChanPerfCurr15MinCorrectedBlks;
    *ret_len = sizeof(atucChannelPerfDataStruct.
            adslAtucChanPerfCurr15MinCorrectedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAtucChanPerfCurr15MinUncorrectBlks column and set
         ret_len to its proper size in bytes. */
u_int32      *
get_adslAtucChanPerfCurr15MinUncorrectBlks(void *data_context, size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_CURR_15MIN_UNCORR_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
        (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
            ATUC_CHAN_PERF_CURR_15MIN_UNCORR_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfCurr15MinUnCorrBlk CMV fail\n"));

    CLR_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_CURR_15MIN_UNCORR_BLK_FLAG);
    long_ret=atucChannelPerfDataStruct.adslAtucChanPerfCurr15MinUncorrectBlks;
    *ret_len = sizeof(atucChannelPerfDataStruct.
            adslAtucChanPerfCurr15MinUncorrectBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAtucChanPerfCurr1DayTimeElapsed column and set
         ret_len to its proper size in bytes. */
u_int32         *
get_adslAtucChanPerfCurr1DayTimeElapsed(void *data_context,
                                        size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_CURR_1DAY_TIME_ELAPSED_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,(void *) &
        atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
            ATUC_CHAN_PERF_CURR_1DAY_TIME_ELAPSED_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfCurr1Day CMV fail\n"));

    CLR_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_CURR_1DAY_TIME_ELAPSED_FLAG);
    long_ret=atucChannelPerfDataStruct.adslAtucChanPerfCurr1DayTimeElapsed;
    *ret_len = sizeof(atucChannelPerfDataStruct.
            adslAtucChanPerfCurr1DayTimeElapsed);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAtucChanPerfCurr1DayReceivedBlks column and set
         ret_len to its proper size in bytes. */
u_int32         *
get_adslAtucChanPerfCurr1DayReceivedBlks(void *data_context, size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_CURR_1DAY_RECV_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
        (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
            ATUC_CHAN_PERF_CURR_1DAY_RECV_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfCurr1DayRecvBlk CMV fail\n"));

    CLR_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_CURR_1DAY_RECV_BLK_FLAG);
    long_ret=atucChannelPerfDataStruct.adslAtucChanPerfCurr1DayReceivedBlks;
    *ret_len = sizeof(atucChannelPerfDataStruct.
                adslAtucChanPerfCurr1DayReceivedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAtucChanPerfCurr1DayTransmittedBlks column and set
         ret_len to its proper size in bytes. */
u_int32         *
get_adslAtucChanPerfCurr1DayTransmittedBlks(void *data_context,
     size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_CURR_1DAY_TX_BLK_FLAG);
    printf("\n Flags = %0x \n", atucChannelPerfDataStruct.flags);
#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
        (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
            ATUC_CHAN_PERF_CURR_1DAY_TX_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfCurr1DayTxBlk CMV fail\n"));

    CLR_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_CURR_1DAY_TX_BLK_FLAG);
    long_ret=atucChannelPerfDataStruct.adslAtucChanPerfCurr1DayTransmittedBlks;
    *ret_len = sizeof(atucChannelPerfDataStruct.
                adslAtucChanPerfCurr1DayTransmittedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAtucChanPerfCurr1DayCorrectedBlks column and set
         ret_len to its proper size in bytes. */
u_int32         *
get_adslAtucChanPerfCurr1DayCorrectedBlks(void *data_context, size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_CURR_1DAY_CORR_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
        (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
            ATUC_CHAN_PERF_CURR_1DAY_CORR_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfCurr1DayCorrBlk CMV fail\n"));

    CLR_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_CURR_1DAY_CORR_BLK_FLAG);
    long_ret=atucChannelPerfDataStruct.adslAtucChanPerfCurr1DayCorrectedBlks;
    *ret_len = sizeof(atucChannelPerfDataStruct.
            adslAtucChanPerfCurr1DayCorrectedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAtucChanPerfCurr1DayUncorrectBlks column and set
         ret_len to its proper size in bytes. */
u_int32         *
get_adslAtucChanPerfCurr1DayUncorrectBlks(void *data_context, size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_CURR_1DAY_UNCORR_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
        (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
         ATUC_CHAN_PERF_CURR_1DAY_UNCORR_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfCurr1DayUnCorrBlk CMV fail\n"));

    CLR_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_CURR_1DAY_UNCORR_BLK_FLAG);
    long_ret=atucChannelPerfDataStruct.adslAtucChanPerfCurr1DayUncorrectBlks;
    *ret_len = sizeof(atucChannelPerfDataStruct.
            adslAtucChanPerfCurr1DayUncorrectBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAtucChanPerfPrev1DayMoniSecs column and set
         ret_len to its proper size in bytes. */
int           *
get_adslAtucChanPerfPrev1DayMoniSecs(void *data_context, size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_PREV_1DAY_MONI_SEC_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
        (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
            ATUC_CHAN_PERF_PREV_1DAY_MONI_SEC_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfPrev1DayMonSec CMV fail\n"));

    CLR_FLAG(&atucChannelPerfDataStruct.flags,
            ATUC_CHAN_PERF_PREV_1DAY_MONI_SEC_FLAG);
    long_ret=atucChannelPerfDataStruct.adslAtucChanPerfPrev1DayMoniSecs;
    *ret_len = sizeof(atucChannelPerfDataStruct.
                adslAtucChanPerfPrev1DayMoniSecs);
    return (int *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAtucChanPerfPrev1DayReceivedBlks column and set
         ret_len to its proper size in bytes. */
u_int32         *
get_adslAtucChanPerfPrev1DayReceivedBlks(void *data_context, size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_PREV_1DAY_RECV_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
        (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_PREV_1DAY_RECV_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfPrev1DayRecvBlk CMV fail\n"));

    CLR_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_CURR_1DAY_RECV_BLK_FLAG);
    long_ret=atucChannelPerfDataStruct.adslAtucChanPerfPrev1DayReceivedBlks;
    *ret_len = sizeof(atucChannelPerfDataStruct.
            adslAtucChanPerfPrev1DayReceivedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAtucChanPerfPrev1DayTransmittedBlks column and set
         ret_len to its proper size in bytes. */
u_int32         *
get_adslAtucChanPerfPrev1DayTransmittedBlks(void *data_context,
    size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_PREV_1DAY_TX_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
        (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_PREV_1DAY_TX_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfPrev1DayTxBlk CMV fail\n"));

    CLR_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_PREV_1DAY_TX_BLK_FLAG);
    long_ret=atucChannelPerfDataStruct.adslAtucChanPerfPrev1DayTransmittedBlks;
    *ret_len = sizeof(atucChannelPerfDataStruct.
            adslAtucChanPerfPrev1DayTransmittedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAtucChanPerfPrev1DayCorrectedBlks column and set
         ret_len to its proper size in bytes. */
u_int32         *
get_adslAtucChanPerfPrev1DayCorrectedBlks(void *data_context, size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_PREV_1DAY_CORR_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
        (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
            ATUC_CHAN_PERF_PREV_1DAY_CORR_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfPrev1DayCorrBlk CMV fail\n"));
       
    CLR_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_PREV_1DAY_CORR_BLK_FLAG);
    long_ret=atucChannelPerfDataStruct.adslAtucChanPerfPrev1DayCorrectedBlks;
    *ret_len = sizeof(atucChannelPerfDataStruct.
            adslAtucChanPerfPrev1DayCorrectedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAtucChanPerfPrev1DayUncorrectBlks column and set
         ret_len to its proper size in bytes. */
u_int32         *
get_adslAtucChanPerfPrev1DayUncorrectBlks(void *data_context,
                                          size_t * ret_len)
{
    struct atucChannelPerfDataEntry atucChannelPerfDataStruct;

    memset(&atucChannelPerfDataStruct,0,sizeof(atucChannelPerfDataEntry));
    atucChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_PREV_1DAY_UNCORR_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA, &atucChannelPerfDataStruct);
#else
    get_adslAtucChanPerfDataTable(Fd, GET_ADSL_ATUC_CHAN_PERF_DATA,
        (void *) &atucChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&atucChannelPerfDataStruct.flags,
            ATUC_CHAN_PERF_PREV_1DAY_UNCORR_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUC", "ChanPerfPrev1DayUnCorrBlk CMV fail\n"));
       
    CLR_FLAG(&atucChannelPerfDataStruct.flags,
        ATUC_CHAN_PERF_PREV_1DAY_UNCORR_BLK_FLAG);
    long_ret=atucChannelPerfDataStruct.adslAtucChanPerfPrev1DayUncorrectBlks;
    *ret_len = sizeof(atucChannelPerfDataStruct.
                adslAtucChanPerfPrev1DayUncorrectBlks);
    return (u_int32 *) &long_ret;
}

#endif


#ifndef ENABLE_DRIVER_CALL
int get_adslAtucChanPerfDataTable(int Fd2,int GET_adsl_ATUC_CHAN_PERF_DATA2,
                        void *atucChanPerfDataValue)
{

    struct atucChannelPerfDataEntry *atucChanPerfData;
    atucChanPerfData = (atucChannelPerfDataEntry *) atucChanPerfDataValue;
    atucChanPerfData->adslAtucChanReceivedBlks = 10;
    atucChanPerfData->adslAtucChanTransmittedBlks = 20;
    atucChanPerfData->adslAtucChanCorrectedBlks = 30;
    atucChanPerfData->adslAtucChanUncorrectBlks = 40;
    atucChanPerfData->adslAtucChanPerfValidIntervals = 10;
    atucChanPerfData->adslAtucChanPerfInvalidIntervals = 20;
    atucChanPerfData->adslAtucChanPerfCurr15MinTimeElapsed = 10;
    atucChanPerfData->adslAtucChanPerfCurr15MinReceivedBlks = 15;
    atucChanPerfData->adslAtucChanPerfCurr15MinTransmittedBlks = 20;
    atucChanPerfData->adslAtucChanPerfCurr15MinCorrectedBlks = 25;
    atucChanPerfData->adslAtucChanPerfCurr15MinUncorrectBlks = 30;
    atucChanPerfData->adslAtucChanPerfCurr1DayTimeElapsed = 20;
    atucChanPerfData->adslAtucChanPerfCurr1DayReceivedBlks = 30;
    atucChanPerfData->adslAtucChanPerfCurr1DayTransmittedBlks = 20;
    atucChanPerfData->adslAtucChanPerfCurr1DayCorrectedBlks = 30;
    atucChanPerfData->adslAtucChanPerfCurr1DayUncorrectBlks = 70;
    atucChanPerfData->adslAtucChanPerfPrev1DayMoniSecs = 80;
    atucChanPerfData->adslAtucChanPerfPrev1DayReceivedBlks = 85;
    atucChanPerfData->adslAtucChanPerfPrev1DayTransmittedBlks = 90;
    atucChanPerfData->adslAtucChanPerfPrev1DayCorrectedBlks = 95;
    atucChanPerfData->adslAtucChanPerfPrev1DayUncorrectBlks = 10;

    return 0;

}
#endif
