/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    : adslAturChanPerfDataTable_access.c
 * Author       : Subbi
 * Date         : 17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      : Amazon
 * Block        : ADSL-MIBs
 *
 * ===========================================================================
 * Contents: This file contains functions for:
 *                 1) Getting the data context pointer & loop context pointer
 *                 2) User-defined data access functions (per column) for data
 *                    in table adslAturChanPerfDataTable
 *
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */

/* ===========================================================================
 * Revision History:
 * Subramani:Changed the return types of adslAturChanPerfValidIntervals,
 * adslAturChanPerfInvalidIntervals and adslAturChanPerfPrev1DayMoniSecs
 * $Log$
 * ===========================================================================
 */

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
 */
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "adslAturChanPerfDataTable_access.h"
#ifdef STUB_IOCTL
#include "adslAturChanPerfDataTable_enums.h"
#endif

/* column number definitions for table adslAturChanPerfDataTable */
#include "adslAturChanPerfDataTable_columns.h"

/*
 * ===========================================================================
 *                           GLOBAL DEFINITIONS
 * ===========================================================================
 */
// *** Global variable definitions
static long long_ret;

/*
 * ===========================================================================
 *                           LOCAL FUNCTIONS
 * ===========================================================================
 */
/** returns the first data point within the adslAturChanPerfDataTable table data.

    Set the my_loop_context variable to the first data point structure
    of your choice (from which you can find the next one).  This could
    be anything from the first node in a linked list, to an integer
    pointer containing the beginning of an array variable.

    Set the my_data_context variable to something to be returned to
    you later that will provide you with the data to return in a given
    row.  This could be the same pointer as what my_loop_context is
    set to, or something different.

    The put_index_data variable contains a list of snmp variable
    bindings, one for each index in your table.  Set the values of
    each appropriately according to the data matching the first row
    and return the put_index_data variable at the end of the function.
*/
netsnmp_variable_list *
adslAturChanPerfDataTable_get_first_data_point(void **my_loop_context,
                                               void **my_data_context,
                                               netsnmp_variable_list *
                                               put_index_data,
                                               netsnmp_iterator_info
                                               *mydata)
{

    int *My_Data_Context;
    My_Data_Context = SNMP_MALLOC_TYPEDEF(int);
    if (!My_Data_Context) {
       put_index_data = NULL;
       snmp_log(LOG_ERR, "Get-First: adslAturChanPerDataTable: My_Data_Context malloc failed\n");
       return put_index_data;
    }
    *My_Data_Context=IFTYPE_ADSL_FAST_INTERLEAVE;
    *my_data_context=My_Data_Context;

    put_index_data = adslTable_get_first_data_point(my_loop_context,
                                   my_data_context,
                                   put_index_data,
                                   mydata);

    SNMP_FREE(My_Data_Context);
    return put_index_data;

}

/** functionally the same as adslAturChanPerfDataTable_get_first_data_point, but
   my_loop_context has already been set to a previous value and should
   be updated to the next in the list.  For example, if it was a
   linked list, you might want to cast it to your local data type and
   then return my_loop_context->next.  The my_data_context pointer
   should be set to something you need later and the indexes in
   put_index_data updated again. */
netsnmp_variable_list *
adslAturChanPerfDataTable_get_next_data_point(void **my_loop_context,
                                              void **my_data_context,
                                              netsnmp_variable_list *
                                              put_index_data,
                                              netsnmp_iterator_info
                                              *mydata)
{

    int *My_Data_Context;
    My_Data_Context = SNMP_MALLOC_TYPEDEF(int);
    if (!My_Data_Context) {
       put_index_data = NULL;
       snmp_log(LOG_ERR, "Get-Next: adslAturChanPerDataTable: My_Data_Context malloc failed\n");
       return put_index_data;
    }
    *My_Data_Context=IFTYPE_ADSL_FAST_INTERLEAVE;
    *my_data_context=My_Data_Context;

     put_index_data = adslTable_get_next_data_point(my_loop_context,
                                   my_data_context,
                                   put_index_data,
                                   mydata);

    SNMP_FREE(My_Data_Context);
    return put_index_data;
}


/*
 *  User-defined data access functions (per column) for data in table
    adslAturChanPerfDataTable
 */
/*
 * NOTE:
 * - these get_ routines MUST return data that will not be freed (ie,
 *   use static variables or persistent data).  It will be copied, if
 *   needed, immediately after the get_ routine has been called.
 * - these SET routines must copy the incoming data and can not take
 *   ownership of the memory passed in by the val pointer.
 */

#if defined(HAVE_OPTIMIZED_CODE)

u_int32  *
get_adslAturChanBlksData(void *data_context, size_t * ret_len,
			unsigned int var)
{
  unsigned int flags = 0;
  struct aturChannelPerfDataEntry aturChannelPerfDataStruct;
  memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
  aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
  
  switch (var)  {

        case COLUMN_ADSLATURCHANRECEIVEDBLKS:
	   flags = ATUR_CHAN_RECV_BLK_FLAG;
	   break;

        case COLUMN_ADSLATURCHANTRANSMITTEDBLKS:
	   flags = ATUR_CHAN_TX_BLK_FLAG;
	   break;

        case COLUMN_ADSLATURCHANCORRECTEDBLKS:
	   flags = ATUR_CHAN_CORR_BLK_FLAG;
	   break;

        case COLUMN_ADSLATURCHANUNCORRECTBLKS:
	   flags = ATUR_CHAN_UNCORR_BLK_FLAG;
	   break;

     	default:
     	   DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
     	   return NULL;
  }

  SET_FLAG(&aturChannelPerfDataStruct.flags, flags);
#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
        (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags, flags) == 0)
       DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfDataTable: GET- %x CMV fail\n", flags));

    switch (flags)  {
	    
	case ATUR_CHAN_RECV_BLK_FLAG:
    	   long_ret = aturChannelPerfDataStruct.adslAturChanReceivedBlks;
	   break;

	case ATUR_CHAN_TX_BLK_FLAG:
    	   long_ret = aturChannelPerfDataStruct.adslAturChanTransmittedBlks;
	   break;

	case ATUR_CHAN_CORR_BLK_FLAG:
    	   long_ret = aturChannelPerfDataStruct.adslAturChanCorrectedBlks;
	   break;

	case ATUR_CHAN_UNCORR_BLK_FLAG:
    	   long_ret = aturChannelPerfDataStruct.adslAturChanUncorrectBlks;
	   break;
		
        default:
     	    DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
            return NULL;
    }
    
    CLR_FLAG(&aturChannelPerfDataStruct.flags, flags);
    *ret_len = sizeof(u_int32);
    return (u_int32 *) &long_ret;
}


int *
get_adslAturChanPerfIntervalData(void *data_context, size_t * ret_len,
			unsigned int var)
{
  unsigned int flags = 0;
  struct aturChannelPerfDataEntry aturChannelPerfDataStruct;
  memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
  aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);

  switch (var) {

      case COLUMN_ADSLATURCHANPERFVALIDINTERVALS:
	 flags = ATUR_CHAN_PERF_VALID_INTVL_FLAG;
	 break;
	 
      case COLUMN_ADSLATURCHANPERFINVALIDINTERVALS:
	 flags = ATUR_CHAN_PERF_INVALID_INTVL_FLAG;
	 break;

      case COLUMN_ADSLATURCHANPERFPREV1DAYMONISECS:
	 flags = ATUR_CHAN_PERF_PREV_1DAY_MONI_SEC_FLAG;
	 break;
	 
      default:
     	 DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
     	 return NULL;
 }
  
 SET_FLAG(&aturChannelPerfDataStruct.flags, flags);
#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
        (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags, flags) == 0)
       DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfDataTable: GET- %x CMV fail\n", flags));

    switch (flags)  {
	    
	case ATUR_CHAN_PERF_VALID_INTVL_FLAG:
    	   long_ret = aturChannelPerfDataStruct.adslAturChanPerfValidIntervals;
	   break;

	case ATUR_CHAN_PERF_INVALID_INTVL_FLAG:
    	   long_ret = aturChannelPerfDataStruct.adslAturChanPerfInvalidIntervals;
	   break;

	case ATUR_CHAN_PERF_PREV_1DAY_MONI_SEC_FLAG:
    	   long_ret = aturChannelPerfDataStruct.adslAturChanPerfPrev1DayMoniSecs;
	   break;

        default:
     	    DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
            return NULL;
    }
    
    CLR_FLAG(&aturChannelPerfDataStruct.flags, flags);
    *ret_len = sizeof(int);
    return (int *) &long_ret;
}


u_int32  *
get_adslAturChanPerfStatsData(void *data_context, size_t * ret_len,
			unsigned int var)
{
  unsigned int flags = 0;
  struct aturChannelPerfDataEntry aturChannelPerfDataStruct;
  memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
  aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);

  switch (var) {

      case COLUMN_ADSLATURCHANPERFCURR15MINTIMEELAPSED:
	 flags = ATUR_CHAN_PERF_CURR_15MIN_TIME_ELAPSED_FLAG; 
         break;
	 
      case COLUMN_ADSLATURCHANPERFCURR15MINRECEIVEDBLKS:
	 flags = ATUR_CHAN_PERF_CURR_15MIN_RECV_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATURCHANPERFCURR15MINTRANSMITTEDBLKS:
	 flags = ATUR_CHAN_PERF_CURR_15MIN_TX_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATURCHANPERFCURR15MINCORRECTEDBLKS:
	 flags = ATUR_CHAN_PERF_CURR_15MIN_CORR_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATURCHANPERFCURR15MINUNCORRECTBLKS:
	 flags = ATUR_CHAN_PERF_CURR_15MIN_UNCORR_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATURCHANPERFCURR1DAYTIMEELAPSED:
	 flags = ATUR_CHAN_PERF_CURR_1DAY_TIME_ELAPSED_FLAG;
	 break;
	  
      case COLUMN_ADSLATURCHANPERFCURR1DAYRECEIVEDBLKS:
	 flags = ATUR_CHAN_PERF_CURR_1DAY_RECV_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATURCHANPERFCURR1DAYTRANSMITTEDBLKS:
	 flags = ATUR_CHAN_PERF_CURR_1DAY_TX_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATURCHANPERFCURR1DAYCORRECTEDBLKS:
	 flags = ATUR_CHAN_PERF_CURR_1DAY_CORR_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATURCHANPERFCURR1DAYUNCORRECTBLKS:
	 flags = ATUR_CHAN_PERF_CURR_1DAY_UNCORR_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATURCHANPERFPREV1DAYRECEIVEDBLKS:
	 flags = ATUR_CHAN_PERF_PREV_1DAY_RECV_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATURCHANPERFPREV1DAYTRANSMITTEDBLKS:
	 flags = ATUR_CHAN_PERF_PREV_1DAY_TRANS_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATURCHANPERFPREV1DAYCORRECTEDBLKS:
	 flags = ATUR_CHAN_PERF_PREV_1DAY_CORR_BLK_FLAG;
	 break;
	  
      case COLUMN_ADSLATURCHANPERFPREV1DAYUNCORRECTBLKS:
	 flags = ATUR_CHAN_PERF_PREV_1DAY_UNCORR_BLK_FLAG;
	 break;
	 
      default:
     	 DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
         return NULL;
 }

 SET_FLAG(&aturChannelPerfDataStruct.flags, flags);
#ifdef ENABLE_DRIVER_CALL
     adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
     get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
			         (void *) &aturChannelPerfDataStruct);
#endif
     if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags, flags) == 0)
            DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfDataTable: GET- %x CMV fail\n", flags));

     switch (flags)  {

	 case ATUR_CHAN_PERF_CURR_15MIN_TIME_ELAPSED_FLAG:
	    long_ret = aturChannelPerfDataStruct.adslAturChanPerfCurr15MinTimeElapsed;		 
            break;
	 
	 case ATUR_CHAN_PERF_CURR_15MIN_RECV_BLK_FLAG:
	    long_ret = aturChannelPerfDataStruct.adslAturChanPerfCurr15MinReceivedBlks;
	    break;
	  
	 case ATUR_CHAN_PERF_CURR_15MIN_TX_BLK_FLAG:
	    long_ret = aturChannelPerfDataStruct.adslAturChanPerfCurr15MinTransmittedBlks;
	    break;
	  
	 case ATUR_CHAN_PERF_CURR_15MIN_CORR_BLK_FLAG:
	    long_ret = aturChannelPerfDataStruct.adslAturChanPerfCurr15MinCorrectedBlks;
	    break;
	  
	 case ATUR_CHAN_PERF_CURR_15MIN_UNCORR_BLK_FLAG:
	    long_ret = aturChannelPerfDataStruct.adslAturChanPerfCurr15MinUncorrectBlks;
	    break;
	  
	 case ATUR_CHAN_PERF_CURR_1DAY_TIME_ELAPSED_FLAG:
	    long_ret = aturChannelPerfDataStruct.adslAturChanPerfCurr1DayTimeElapsed;
	    break;
	  
	 case ATUR_CHAN_PERF_CURR_1DAY_RECV_BLK_FLAG:
	    long_ret = aturChannelPerfDataStruct.adslAturChanPerfCurr1DayReceivedBlks;
	    break;
	  
	 case ATUR_CHAN_PERF_CURR_1DAY_TX_BLK_FLAG:
	    long_ret = aturChannelPerfDataStruct.adslAturChanPerfCurr1DayTransmittedBlks;
	    break;
	  
	 case ATUR_CHAN_PERF_CURR_1DAY_CORR_BLK_FLAG:
	    long_ret = aturChannelPerfDataStruct.adslAturChanPerfCurr1DayCorrectedBlks;
            break;
	  
	 case ATUR_CHAN_PERF_CURR_1DAY_UNCORR_BLK_FLAG:
	    long_ret = aturChannelPerfDataStruct.adslAturChanPerfCurr1DayUncorrectBlks;
	    break;
	  
	 case ATUR_CHAN_PERF_PREV_1DAY_RECV_BLK_FLAG:
	   long_ret = aturChannelPerfDataStruct.adslAturChanPerfPrev1DayReceivedBlks; 
	    break;
	  
	 case ATUR_CHAN_PERF_PREV_1DAY_TRANS_BLK_FLAG:
	    long_ret = aturChannelPerfDataStruct.adslAturChanPerfPrev1DayTransmittedBlks;
	    break;
	  
	 case ATUR_CHAN_PERF_PREV_1DAY_CORR_BLK_FLAG:
            long_ret = aturChannelPerfDataStruct.adslAturChanPerfPrev1DayCorrectedBlks;
	    break;
	  
	 case ATUR_CHAN_PERF_PREV_1DAY_UNCORR_BLK_FLAG:
	    long_ret = aturChannelPerfDataStruct.adslAturChanPerfPrev1DayUncorrectBlks;
	    break;
	 
         default:
     	    DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
            return NULL;
     }
     
    CLR_FLAG(&aturChannelPerfDataStruct.flags, flags);
    *ret_len = sizeof(u_int32);
    return (u_int32 *) &long_ret;
}

#else

/** XXX: return a data pointer to the data for the adslAturChanReceivedBlks
    column and set ret_len to its proper size in bytes. */
u_int32         *
get_adslAturChanReceivedBlks(void *data_context, size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;
    memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags, ATUR_CHAN_RECV_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
        (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_RECV_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfRecvBlk CMV fail\n"));
       
    CLR_FLAG(&aturChannelPerfDataStruct.flags, ATUR_CHAN_RECV_BLK_FLAG);
    long_ret = aturChannelPerfDataStruct.adslAturChanReceivedBlks;
    *ret_len = sizeof(aturChannelPerfDataStruct.adslAturChanReceivedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the adslAturChanTransmittedBlks
    column and set ret_len to its proper size in bytes. */
u_int32         *
get_adslAturChanTransmittedBlks(void *data_context, size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;

    memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags, ATUR_CHAN_TX_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
        (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_TX_BLK_FLAG) == 0)
       DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfTxBlk CMV fail\n"));

    CLR_FLAG(&aturChannelPerfDataStruct.flags, ATUR_CHAN_TX_BLK_FLAG);
    long_ret = aturChannelPerfDataStruct.adslAturChanTransmittedBlks;
    *ret_len = sizeof(aturChannelPerfDataStruct.adslAturChanTransmittedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the adslAturChanCorrectedBlks
    column and set ret_len to its proper size in bytes. */
u_int32         *
get_adslAturChanCorrectedBlks(void *data_context, size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;

   memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags, ATUR_CHAN_CORR_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
        (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_CORR_BLK_FLAG) == 0) 
      DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfCorrBlk CMV fail\n"));

    CLR_FLAG(&aturChannelPerfDataStruct.flags, ATUR_CHAN_CORR_BLK_FLAG);
    long_ret = aturChannelPerfDataStruct.adslAturChanCorrectedBlks;
    *ret_len = sizeof(aturChannelPerfDataStruct.adslAturChanCorrectedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the adslAturChanUncorrectBlks
    column and set ret_len to its proper size in bytes. */
u_int32         *
get_adslAturChanUncorrectBlks(void *data_context, size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;

    memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags, ATUR_CHAN_UNCORR_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
        (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags, 
			ATUR_CHAN_UNCORR_BLK_FLAG) == 0)
       DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfUnCorrBlk CMV fail\n"));

    CLR_FLAG(&aturChannelPerfDataStruct.flags, ATUR_CHAN_UNCORR_BLK_FLAG);
    long_ret = aturChannelPerfDataStruct.adslAturChanUncorrectBlks;
    *ret_len = sizeof(aturChannelPerfDataStruct.adslAturChanUncorrectBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAturChanPerfValidIntervals column and set ret_len to its proper size
    in bytes. */
int           *
get_adslAturChanPerfValidIntervals(void *data_context, size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;

    memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags, ATUR_CHAN_PERF_VALID_INTVL_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
        (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_VALID_INTVL_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfValidIntvl CMV fail\n"));

    CLR_FLAG(&aturChannelPerfDataStruct.flags, ATUR_CHAN_PERF_VALID_INTVL_FLAG);
    long_ret = aturChannelPerfDataStruct.adslAturChanPerfValidIntervals;
    *ret_len = sizeof(aturChannelPerfDataStruct.adslAturChanPerfValidIntervals);
    return (int *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAturChanPerfInvalidIntervals column and set ret_len to its
    proper size in bytes. */
int           *
get_adslAturChanPerfInvalidIntervals(void *data_context, size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;

    memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_INVALID_INTVL_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
        (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_INVALID_INTVL_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfInvalidIntvl CMV fail\n"));

    CLR_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_INVALID_INTVL_FLAG);
    long_ret = aturChannelPerfDataStruct.adslAturChanPerfInvalidIntervals;
  *ret_len = sizeof(aturChannelPerfDataStruct.adslAturChanPerfInvalidIntervals);
    return (int *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAturChanPerfCurr15MinTimeElapsed column and set ret_len to its
    proper size in bytes. */
u_int32         *
get_adslAturChanPerfCurr15MinTimeElapsed(void *data_context, size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;

    memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_15MIN_TIME_ELAPSED_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
        (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_15MIN_TIME_ELAPSED_FLAG) == 0)
       DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfCurr15Min CMV fail\n"));

    CLR_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_15MIN_TIME_ELAPSED_FLAG);
    long_ret = aturChannelPerfDataStruct.adslAturChanPerfCurr15MinTimeElapsed;
    *ret_len = sizeof(aturChannelPerfDataStruct.
            adslAturChanPerfCurr15MinTimeElapsed);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAturChanPerfCurr15MinReceivedBlks column and set ret_len to its
    proper size in bytes. */
u_int32       *
get_adslAturChanPerfCurr15MinReceivedBlks(void *data_context, size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;

    memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_15MIN_RECV_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
        (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_15MIN_RECV_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfCurr15MinRecvBlk CMV fail\n"));

    CLR_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_15MIN_RECV_BLK_FLAG);
    long_ret = aturChannelPerfDataStruct.adslAturChanPerfCurr15MinReceivedBlks;
    *ret_len = sizeof(aturChannelPerfDataStruct.
            adslAturChanPerfCurr15MinReceivedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAturChanPerfCurr15MinTransmittedBlks column and set ret_len to
    its proper size in bytes. */
u_int32      *
get_adslAturChanPerfCurr15MinTransmittedBlks(void *data_context,
    size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;

    memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_15MIN_TX_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
        (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_15MIN_TX_BLK_FLAG) == 0)
      DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfCurr15MinTxBlk CMV fail\n"));

    CLR_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_15MIN_TX_BLK_FLAG);
    long_ret =
            aturChannelPerfDataStruct.adslAturChanPerfCurr15MinTransmittedBlks;
    *ret_len = sizeof(aturChannelPerfDataStruct.
            adslAturChanPerfCurr15MinTransmittedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAturChanPerfCurr15MinCorrectedBlks column and set ret_len to
    its proper size in bytes. */
u_int32      *
get_adslAturChanPerfCurr15MinCorrectedBlks(void *data_context, size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;

    memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_15MIN_CORR_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
        (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_15MIN_CORR_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfCurr15MinCorrBlk CMV fail\n"));
       
    CLR_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_15MIN_CORR_BLK_FLAG);
    long_ret = aturChannelPerfDataStruct.adslAturChanPerfCurr15MinCorrectedBlks;
    *ret_len = sizeof(aturChannelPerfDataStruct.
                      adslAturChanPerfCurr15MinCorrectedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAturChanPerfCurr15MinUncorrectBlks column and set ret_len to its
    proper size in bytes. */
u_int32      *
get_adslAturChanPerfCurr15MinUncorrectBlks(void *data_context, size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;

    memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_15MIN_UNCORR_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
        (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_15MIN_UNCORR_BLK_FLAG) == 0)
       DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfCurr15MinUnCorrBlk CMV fail\n"));

    CLR_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_15MIN_UNCORR_BLK_FLAG);
    long_ret = aturChannelPerfDataStruct.adslAturChanPerfCurr15MinUncorrectBlks;
    *ret_len = sizeof(aturChannelPerfDataStruct.
            adslAturChanPerfCurr15MinUncorrectBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAturChanPerfCurr1DayTimeElapsed column and set ret_len to its
    proper size in bytes. */
u_int32         *
get_adslAturChanPerfCurr1DayTimeElapsed(void *data_context, size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;

    memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_1DAY_TIME_ELAPSED_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
        (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_1DAY_TIME_ELAPSED_FLAG) == 0)
       DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfCurr1Day CMV fail\n"));

    CLR_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_1DAY_TIME_ELAPSED_FLAG);
    long_ret = aturChannelPerfDataStruct.adslAturChanPerfCurr1DayTimeElapsed;
    *ret_len = sizeof(aturChannelPerfDataStruct.
                adslAturChanPerfCurr1DayTimeElapsed);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAturChanPerfCurr1DayReceivedBlks column and set ret_len to its
    proper size in bytes. */
u_int32         *
get_adslAturChanPerfCurr1DayReceivedBlks(void *data_context, size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;

    memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_1DAY_RECV_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
        (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_1DAY_RECV_BLK_FLAG) == 0)
     DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfCurr1DayRecvBlk CMV fail\n"));

    CLR_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_1DAY_RECV_BLK_FLAG);
    long_ret = aturChannelPerfDataStruct.adslAturChanPerfCurr1DayReceivedBlks;
    *ret_len = sizeof(aturChannelPerfDataStruct.
                    adslAturChanPerfCurr1DayReceivedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAturChanPerfCurr1DayTransmittedBlks column and set ret_len to
    its proper size in bytes. */
u_int32         *
get_adslAturChanPerfCurr1DayTransmittedBlks(void *data_context,
    size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;

    memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_1DAY_TX_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
        (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_1DAY_TX_BLK_FLAG) == 0) 
     DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfCurr1DayTxBlk CMV fail\n"));

    CLR_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_1DAY_TX_BLK_FLAG);
   long_ret = aturChannelPerfDataStruct.adslAturChanPerfCurr1DayTransmittedBlks;
    *ret_len = sizeof(aturChannelPerfDataStruct.
            adslAturChanPerfCurr1DayTransmittedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAturChanPerfCurr1DayCorrectedBlks column and set ret_len to its
    proper size in bytes. */
u_int32         *
get_adslAturChanPerfCurr1DayCorrectedBlks(void *data_context, size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;

    memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_1DAY_CORR_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
        (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_1DAY_CORR_BLK_FLAG) == 0) 
     DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfCurr1DayCorrBlk CMV fail\n"));

    CLR_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_1DAY_CORR_BLK_FLAG);
    long_ret = aturChannelPerfDataStruct.adslAturChanPerfCurr1DayCorrectedBlks;
    *ret_len = sizeof(aturChannelPerfDataStruct.
            adslAturChanPerfCurr1DayCorrectedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAturChanPerfCurr1DayUncorrectBlks column and set ret_len to
    its proper size in bytes. */
u_int32         *
get_adslAturChanPerfCurr1DayUncorrectBlks(void *data_context, size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;

    memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_1DAY_UNCORR_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
        (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_1DAY_UNCORR_BLK_FLAG) == 0)
     DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfCurr1DayUnCorrBlk CMV fail\n"));

    CLR_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_1DAY_UNCORR_BLK_FLAG);
    long_ret = aturChannelPerfDataStruct.adslAturChanPerfCurr1DayUncorrectBlks;
    *ret_len = sizeof(aturChannelPerfDataStruct.
                    adslAturChanPerfCurr1DayUncorrectBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAturChanPerfPrev1DayMoniSecs column and set ret_len to its
    proper size in bytes. */
int           *
get_adslAturChanPerfPrev1DayMoniSecs(void *data_context, size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;

    memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_PREV_1DAY_MONI_SEC_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
            (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_PREV_1DAY_MONI_SEC_FLAG) == 0) 
     DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfPrev1DayMonSec CMV fail\n"));

    CLR_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_PREV_1DAY_MONI_SEC_FLAG);
    long_ret = aturChannelPerfDataStruct.adslAturChanPerfPrev1DayMoniSecs;
  *ret_len = sizeof(aturChannelPerfDataStruct.adslAturChanPerfPrev1DayMoniSecs);
    return (int *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAturChanPerfPrev1DayReceivedBlks column and set ret_len to its
    proper size in bytes. */
u_int32         *
get_adslAturChanPerfPrev1DayReceivedBlks(void *data_context, size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;

    memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_PREV_1DAY_RECV_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
        (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_PREV_1DAY_RECV_BLK_FLAG) == 0)
      DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfPrev1DayRecvBlk CMV fail\n"));

    CLR_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_CURR_1DAY_RECV_BLK_FLAG);
    long_ret = aturChannelPerfDataStruct.adslAturChanPerfPrev1DayReceivedBlks;
    *ret_len = sizeof(aturChannelPerfDataStruct.
                    adslAturChanPerfPrev1DayReceivedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAturChanPerfPrev1DayTransmittedBlks column and set ret_len to
    its proper size in bytes. */
u_int32 *
get_adslAturChanPerfPrev1DayTransmittedBlks(void *data_context,
        size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;

    memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_PREV_1DAY_TRANS_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
        (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_PREV_1DAY_TRANS_BLK_FLAG) == 0) 
     DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfPrev1DayTxBlk CMV fail\n"));

    CLR_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_PREV_1DAY_TRANS_BLK_FLAG);
   long_ret = aturChannelPerfDataStruct.adslAturChanPerfPrev1DayTransmittedBlks;
    *ret_len = sizeof(aturChannelPerfDataStruct.
            adslAturChanPerfPrev1DayTransmittedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAturChanPerfPrev1DayCorrectedBlks column and set ret_len to
    its proper size in bytes. */
u_int32         *
get_adslAturChanPerfPrev1DayCorrectedBlks(void *data_context, size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;

    memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_PREV_1DAY_CORR_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
            (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags,
            ATUR_CHAN_PERF_PREV_1DAY_CORR_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfPrev1DayCorrBlk CMV fail\n"));

    CLR_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_PREV_1DAY_CORR_BLK_FLAG);
    long_ret = aturChannelPerfDataStruct.adslAturChanPerfPrev1DayCorrectedBlks;
    *ret_len = sizeof(aturChannelPerfDataStruct.
                        adslAturChanPerfPrev1DayCorrectedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAturChanPerfPrev1DayUncorrectBlks column and set ret_len to
    its proper size in bytes. */
u_int32         *
get_adslAturChanPerfPrev1DayUncorrectBlks(void *data_context, size_t * ret_len)
{
    struct aturChannelPerfDataEntry aturChannelPerfDataStruct;

    memset(&aturChannelPerfDataStruct,0,sizeof(aturChannelPerfDataEntry));
    aturChannelPerfDataStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&aturChannelPerfDataStruct.flags,
            ATUR_CHAN_PERF_PREV_1DAY_UNCORR_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA, &aturChannelPerfDataStruct);
#else
    get_adslAturChanPerfDataTable(Fd, GET_ADSL_ATUR_CHAN_PERF_DATA,
            (void *) &aturChannelPerfDataStruct);
#endif
    if (IS_FLAG_SET(&aturChannelPerfDataStruct.flags,
            ATUR_CHAN_PERF_PREV_1DAY_UNCORR_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUR", "ChanPerfPrev1DayUnCorrBlk CMV fail\n"));

    CLR_FLAG(&aturChannelPerfDataStruct.flags,
        ATUR_CHAN_PERF_PREV_1DAY_UNCORR_BLK_FLAG);
    long_ret = aturChannelPerfDataStruct.adslAturChanPerfPrev1DayUncorrectBlks;
    *ret_len = sizeof(aturChannelPerfDataStruct.
                        adslAturChanPerfPrev1DayUncorrectBlks);
    return (u_int32 *) &long_ret;
}

#endif


#ifndef ENABLE_DRIVER_CALL
int get_adslAturChanPerfDataTable(int Fd2,int GET_adsl_ATUR_CHAN_PERF_DATA2,
        void *aturChanPerfDataValue)
{

    struct aturChannelPerfDataEntry *aturChanPerfData;
    aturChanPerfData = (aturChannelPerfDataEntry *) aturChanPerfDataValue;
    aturChanPerfData->adslAturChanReceivedBlks = 110;
    aturChanPerfData->adslAturChanTransmittedBlks = 120;
    aturChanPerfData->adslAturChanCorrectedBlks = 130;
    aturChanPerfData->adslAturChanUncorrectBlks = 140;
    aturChanPerfData->adslAturChanPerfValidIntervals = 80;
    aturChanPerfData->adslAturChanPerfInvalidIntervals = 90;
    aturChanPerfData->adslAturChanPerfCurr15MinTimeElapsed = 110;
    aturChanPerfData->adslAturChanPerfCurr15MinReceivedBlks = 115;
    aturChanPerfData->adslAturChanPerfCurr15MinTransmittedBlks = 120;
    aturChanPerfData->adslAturChanPerfCurr15MinCorrectedBlks = 125;
    aturChanPerfData->adslAturChanPerfCurr15MinUncorrectBlks = 130;
    aturChanPerfData->adslAturChanPerfCurr1DayTimeElapsed = 210;
    aturChanPerfData->adslAturChanPerfCurr1DayReceivedBlks = 320;
    aturChanPerfData->adslAturChanPerfCurr1DayTransmittedBlks = 240;
    aturChanPerfData->adslAturChanPerfCurr1DayCorrectedBlks = 360;
    aturChanPerfData->adslAturChanPerfCurr1DayUncorrectBlks = 470;
    aturChanPerfData->adslAturChanPerfPrev1DayMoniSecs = 580;
    aturChanPerfData->adslAturChanPerfPrev1DayReceivedBlks = 685;
    aturChanPerfData->adslAturChanPerfPrev1DayTransmittedBlks = 790;
    aturChanPerfData->adslAturChanPerfPrev1DayCorrectedBlks = 895;
    aturChanPerfData->adslAturChanPerfPrev1DayUncorrectBlks = 910;

    return 0;

}
#endif

