/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    : adslAturChanPerfDataTable_access.h
 * Author       : Subbi
 * Date         : 17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      : Amazon
 * Block        : ADSL-MIBs
 *
 * ===========================================================================
 * Contents: This file contains:
 *                 1) User-defined data structure for accessing
 *                    adslAturChanPerfDataTable
 *                 2) User-defined data access functions for data in table
 *                    adslAturChanPerfDataTable
 *                 3) Column accessors functions
 *
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */

/* ===========================================================================
 * Revision History:
 * Subramani:Changed the return types of adslAturChanPerfValidIntervals,
 * adslAturChanPerfInvalidIntervals and adslAturChanPerfPrev1DayMoniSecs
 * $Log$
 * ===========================================================================
 */

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */

#ifndef ADSLATURCHANPERFDATATABLE_ACCESS_H
#define ADSLATURCHANPERFDATATABLE_ACCESS_H

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
 */
#include <adslMIB/adslTable_access.h>

/*
 * ===========================================================================
 *                           USER-DEFINED DATA TYPES
 * ===========================================================================
 */
#ifdef STUB_IOCTL
/** User-defined data structure for accessing adslAturChanPerfDataTable **/
#define AdslPerfTimeElapsed u_int32
#define PerfCurrentCount u_int32
#define AdslPerfCurrDayCount u_int32
#define AdslPerfPrevDayCount u_int32

typedef struct aturChannelPerfDataEntry
{
   int          ifIndex;
   u_int32          adslAturChanReceivedBlks;
   u_int32          adslAturChanTransmittedBlks;
   u_int32          adslAturChanCorrectedBlks;
   u_int32          adslAturChanUncorrectBlks;
   int              adslAturChanPerfValidIntervals;
   int              adslAturChanPerfInvalidIntervals;
   AdslPerfTimeElapsed  adslAturChanPerfCurr15MinTimeElapsed;
   PerfCurrentCount     adslAturChanPerfCurr15MinReceivedBlks;
   PerfCurrentCount     adslAturChanPerfCurr15MinTransmittedBlks;
   PerfCurrentCount     adslAturChanPerfCurr15MinCorrectedBlks;
   PerfCurrentCount     adslAturChanPerfCurr15MinUncorrectBlks;
   AdslPerfTimeElapsed  adslAturChanPerfCurr1DayTimeElapsed;
   AdslPerfCurrDayCount adslAturChanPerfCurr1DayReceivedBlks;
   AdslPerfCurrDayCount adslAturChanPerfCurr1DayTransmittedBlks;
   AdslPerfCurrDayCount adslAturChanPerfCurr1DayCorrectedBlks;
   AdslPerfCurrDayCount adslAturChanPerfCurr1DayUncorrectBlks;
   int                  adslAturChanPerfPrev1DayMoniSecs;
   AdslPerfPrevDayCount adslAturChanPerfPrev1DayReceivedBlks;
   AdslPerfPrevDayCount adslAturChanPerfPrev1DayTransmittedBlks;
   AdslPerfPrevDayCount adslAturChanPerfPrev1DayCorrectedBlks;
   AdslPerfPrevDayCount adslAturChanPerfPrev1DayUncorrectBlks;
   u_int32          flags;
} aturChannelPerfDataEntry;
#endif

/*
 * ===========================================================================
 *                           FUNCTION PROTOTYPES
 * ===========================================================================
 */
/** User-defined data access functions for data in table
    adslAturChanPerfDataTable */
/** row level accessors */
Netsnmp_First_Data_Point adslAturChanPerfDataTable_get_first_data_point;
Netsnmp_Next_Data_Point adslAturChanPerfDataTable_get_next_data_point;

/** column accessors */
#if defined(HAVE_OPTIMIZED_CODE)
u_int32  *
get_adslAturChanBlksData(void *data_context, size_t * ret_len,
			unsigned int var);

int *
get_adslAturChanPerfIntervalData(void *data_context, size_t * ret_len,
			unsigned int var);

u_int32  *
get_adslAturChanPerfStatsData(void *data_context, size_t * ret_len,
			unsigned int var);
#else
u_int32  *get_adslAturChanReceivedBlks(void *data_context, size_t * ret_len);
u_int32  *get_adslAturChanTransmittedBlks(void *data_context, size_t * ret_len);
u_int32  *get_adslAturChanCorrectedBlks(void *data_context, size_t * ret_len);
u_int32  *get_adslAturChanUncorrectBlks(void *data_context, size_t * ret_len);
int     *get_adslAturChanPerfValidIntervals(void *data_context,
            size_t * ret_len);
int     *get_adslAturChanPerfInvalidIntervals(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAturChanPerfCurr15MinTimeElapsed(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAturChanPerfCurr15MinReceivedBlks(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAturChanPerfCurr15MinTransmittedBlks(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAturChanPerfCurr15MinCorrectedBlks(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAturChanPerfCurr15MinUncorrectBlks(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAturChanPerfCurr1DayTimeElapsed(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAturChanPerfCurr1DayReceivedBlks(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAturChanPerfCurr1DayTransmittedBlks(void *data_context,
            size_t *ret_len);
u_int32  *get_adslAturChanPerfCurr1DayCorrectedBlks(void *data_context,
            size_t *ret_len);
u_int32  *get_adslAturChanPerfCurr1DayUncorrectBlks(void *data_context,
            size_t *ret_len);
int     *get_adslAturChanPerfPrev1DayMoniSecs(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAturChanPerfPrev1DayReceivedBlks(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAturChanPerfPrev1DayTransmittedBlks(void *data_context,
            size_t *ret_len);
u_int32  *get_adslAturChanPerfPrev1DayCorrectedBlks(void *data_context,
            size_t *ret_len);
u_int32  *get_adslAturChanPerfPrev1DayUncorrectBlks(void *data_context,
            size_t *ret_len);
#endif

#ifndef ENABLE_DRIVER_CALL
int get_adslAturChanPerfDataTable(int Fd2,int GET_adsl_ATUR_CHAN_PERF_DATA2,void *aturChanPerfDataValue);
#endif

#endif                                   /* ADSLATURCHANPERFDATATABLE_ACCESS_H */
