/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    : adslAturChanTable_access.h
 * Author       : Subbi
 * Date         : 17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      : Amazon
 * Block        : ADSL-MIBs
 *
 * ===========================================================================
 * Contents: This file contains:
 *                 1) User-defined data structure for accessing
 *                    adslAturChanTable
 *                 2) User-defined data access functions for data in table
 *                    adslAturChanTable
 *                 3) Column accessors functions
 *
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */

/* ===========================================================================
 * Revision History:
 *
 * $Log$
 * ===========================================================================
 */

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */

#ifndef ADSLATURCHANTABLE_ACCESS_H
#define ADSLATURCHANTABLE_ACCESS_H

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
 */
#include <adslMIB/adslTable_access.h>

/*
 * ===========================================================================
 *                           USER-DEFINED DATA TYPES
 * ===========================================================================
 */
#ifdef STUB_IOCTL
/** User-defined data structure for accessing adslAturChanTable **/
typedef struct adslAturChanInfo {
    int ifIndex;
    u_int32 interleaveDelay;
    u_int32 currTxRate;
    u_int32 prevTxRate;
    u_int32 crcBlkLen;
    u_char flags;
} adslAturChanInfo;
#endif

/*
 * ===========================================================================
 *                           FUNCTION PROTOTYPES
 * ===========================================================================
 */
/** User-defined data access functions for data in table adslAturChanTable */
/** row level accessors */
Netsnmp_First_Data_Point adslAturChanTable_get_first_data_point;
Netsnmp_Next_Data_Point adslAturChanTable_get_next_data_point;

/** column accessors */
#if defined(HAVE_OPTIMIZED_CODE)
u_int32         *
get_adslAturChanInfo(void *data_context, size_t * ret_len,
		unsigned int var);
#else
u_int32 *get_adslAturChanInterleaveDelay(void *data_context, size_t * ret_len);
u_int32 *get_adslAturChanCurrTxRate(void *data_context, size_t * ret_len);
u_int32 *get_adslAturChanPrevTxRate(void *data_context, size_t * ret_len);
u_int32 *get_adslAturChanCrcBlockLength(void *data_context, size_t * ret_len);
#endif

#ifndef ENABLE_DRIVER_CALL
int  get_adslAturChanTable(int Fd2,int GET_ADSL_atur_CHAN_INFO,
            void *adslAturChanTable);
#endif

#endif                          /* ADSLATURCHANTABLE_ACCESS_H */
