/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    : adslTraps.h
 * Author       : Subbi
 * Date         : 17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      : Amazon
 * Block        : ADSL-MIBs
 *
 * ===========================================================================
 * Contents: This file contains:
 *                 1) Include files
 *                 2) Definitions
 *                 2) Init Function proto-types
 *
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */

/* ===========================================================================
 * Revision History:
 *
 * $Log$
 * ===========================================================================
 */

#ifndef ADSLTRAPS_H
#define ADSLTRAPS_H

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
 */
#include <adslMIB/adslTable_access.h>

/*
 * ===========================================================================
 *                           DEFINITIONS
 * ===========================================================================
 */

#ifdef STUB_IOCTL
/* adslAturTrap constants */
#define ADSL_ATUR_TRAPS             135

/* adslAturTraps Flags */
#define ATUC_PERF_LOFS_THRESH_FLAG      0x1     /* BIT 0th position */
#define ATUC_PERF_LOSS_THRESH_FLAG      0x2     /* BIT 1 */
#define ATUC_PERF_ESS_THRESH_FLAG       0x4     /* BIT 2 */
#define ATUC_RATE_CHANGE_FLAG           0x8     /* BIT 3 */
#define ATUR_PERF_LOFS_THRESH_FLAG      0x10    /* BIT 4 */
#define ATUR_PERF_LOSS_THRESH_FLAG      0x20    /* BIT 5 */
#define ATUR_PERF_LPRS_THRESH_FLAG      0x40    /* BIT 6 */
#define ATUR_PERF_ESS_THRESH_FLAG       0x80    /* BIT 7 */
#define ATUR_RATE_CHANGE_FLAG           0x100   /* BIT 8 */
#endif

/* Constants */
#define SNMP_ADSL_TRAPS_PREFIX          1,3,6,1,2,1,10,94,1,2
#define SNMP_ADSL_ATUC_TRAPS_PREFIX     SNMP_ADSL_TRAPS_PREFIX,1
#define SNMP_ADSL_ATUR_TRAPS_PREFIX     SNMP_ADSL_TRAPS_PREFIX,2

/*
 * ===========================================================================
 *                           FUNCTION PROTOTYPES
 * ===========================================================================
 */

/* prototypes for the Traps */
void init_adslTraps(void);
SNMPAlarmCallback send_adsl_notification;

#endif /* ADSLTRAPS_H */
