/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-LAN-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxDhcp_access.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.scalar.conf,v 1.7 2003/04/08 14:57:04 dts12 Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include <net-snmp/agent/watcher.h>
#include "ifxDhcp_access.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
static char                 cRetVal[MAX_DATA_LEN];
static int                  nDhcpStatus = DHCP_DISABLE;
static x_IFX_CM_Msg         g_xCmMsg;
netsnmp_helper_info         winfo;

void *
ifxDhcpStatus_create_context()
{
    memset (&cRetVal, 0x00, MAX_DATA_LEN);

    if (ifx_GetCfgData(FILE_RC_CONF, "wan_main", "ipoption_adm1", cRetVal) != 1)
    {
        DEBUGMSGTL(("snmpd", "unable get WAN main\n"));
    }

    if ( strcmp(cRetVal, "DHCPC") == 0)
    {
        nDhcpStatus = DHCP_ENABLE;
    }
    else
    {
        nDhcpStatus = DHCP_DISABLE;
    }
}

/** Initializes the ifxDhcpStatus module */
void
init_ifxDhcpStatus(void)
{
    static oid      ifxDhcpStatus_oid[] =
        { 1, 3, 6, 1, 4, 1, IFX_MIB, IFX_PRODUCT, 1, 1, 0 };

    DEBUGMSGTL(("ifxDhcpStatus", "Initializing\n"));

    netsnmp_register_instance(netsnmp_create_handler_registration
                              ("ifxDhcpStatus", A_do_ifxDhcpStatus,
                               ifxDhcpStatus_oid,
                               OID_LENGTH(ifxDhcpStatus_oid),
                               HANDLER_CAN_RWRITE));

    ifxDhcpStatus_create_context();
}

int
A_do_ifxDhcpStatus(netsnmp_mib_handler *handler,
                     netsnmp_handler_registration *reginfo,
                     netsnmp_agent_request_info *reqinfo,
                     netsnmp_request_info *requests)
{
    if (reqinfo->mode == MODE_SET_COMMIT)
    {
        int     nSetReturn = -1;

        if (*requests->requestvb->val.integer == DHCP_ENABLE)
        {
            /* Populate the structure of CM*/
            memset(&g_xCmMsg, 0, sizeof(x_IFX_CM_Msg));
            g_xCmMsg.ucMsgType = IFX_CM_SET_REQ;
            g_xCmMsg.ucInfoType = IFX_CM_APP_NETWORK;
            g_xCmMsg.ucChannel = 0;
            g_xCmMsg.uxData.xNetAddrCfg.ucWanIfType = IFX_CM_WAN_IF_DHCPC;
            snmp_log(LOG_ERR, "ifxDhcpStatus: CM will do reboot.\n");
            if (IFX_CM_SendDataToCM(&g_xCmMsg) != IFX_CM_SUCCESS)
            {
        	    snmp_log(LOG_ERR, "ifxDhcpStatus: Cant send Data to CM.\n");
                return SNMP_ERR_COMMITFAILED;
            }
        }
        else
        if (*requests->requestvb->val.integer == DHCP_DISABLE)
        {
            /* Populate the structure of CM*/
            memset(&g_xCmMsg, 0, sizeof(x_IFX_CM_Msg));
            g_xCmMsg.ucMsgType = IFX_CM_SET_REQ;
            g_xCmMsg.ucInfoType = IFX_CM_APP_NETWORK;
            g_xCmMsg.ucChannel = 0;
            g_xCmMsg.uxData.xNetAddrCfg.ucWanIfType = IFX_CM_WAN_IF_FIXED;
            snmp_log(LOG_ERR, "ifxDhcpStatus: CM will do reboot.\n");
            if (IFX_CM_SendDataToCM(&g_xCmMsg) != IFX_CM_SUCCESS)
            {
        	    snmp_log(LOG_ERR, "ifxDhcpStatus: Cant send Data to CM.\n");
                return SNMP_ERR_COMMITFAILED;
            }
        }
        else
        {
            netsnmp_set_request_error(reqinfo, requests, SNMP_ERR_WRONGVALUE);
        }

        return SNMP_ERR_NOERROR;
    }
    else
    {
        ifxDhcpStatus_create_context();
        winfo.data      = (void *)&nDhcpStatus;
        winfo.data_size = sizeof(nDhcpStatus);
        winfo.type      = ASN_INTEGER;
        winfo.flags     = HELPER_CHECK_MAX_MIN;
        winfo.max_size  = DHCP_DISABLE;
        winfo.min_size  = DHCP_ENABLE;

        return (ifx_helper(handler, reginfo, reqinfo, requests, &winfo));
    }
}
