/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-QOS-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxBuildSwitchTable_checkfns.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.check_values.conf,v 1.6 2003/06/13 18:18:04 hardaker Exp $
 */
/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
*/
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include "ifxBuildSwitchTable_checkfns.h"

/** Decides if an incoming value for the bwVlanPriority mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_bwVlanPriority(int type, int *val, size_t val_len,
                     int *old_val, size_t old_val_len)
{
    int ret;
    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    if (!(*val >= 0 && *val <= 7))
    {
        snmp_log(LOG_ERR, "bwVlanPriority: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the bwVlanId mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_bwVlanId(int type, int *val, size_t val_len,
               int *old_val, size_t old_val_len)
{
    int ret;
    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    if (!(*val >= 0 && *val <= 4095))
    {
        snmp_log(LOG_ERR, "bwVlanId: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the bwAcceptance mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_bwAcceptance(int type, int *val, size_t val_len,
                   int *old_val, size_t old_val_len)
{
    int ret;
    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    if (!(*val >= 0 && *val <= 1))
    {
        snmp_log(LOG_ERR, "bwAcceptance: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}
    
/** Decides if an incoming value for the bwPortPriority mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int    
check_bwPortPriority (int type, int *val, size_t val_len,
                      int *old_val, size_t old_val_len)
{
    int ret;
    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    return SNMP_ERR_NOERROR;
}
