/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-QOS-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxQosSwEnhanceTable_access.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "ifxQosSwEnhanceTable_access.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
static char                 cTag[MAX_TAG_LEN];
static char                 cRetVal[MAX_DATA_LEN];
static unsigned int         nEntryNum = 0;

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
*/
void * 
ifxGetQosSwEnhanceCount()
{
    /* printf("**** ifxGetQosSwEnhanceCount ****\n"); */
    memset (&cRetVal, 0x00, MAX_DATA_LEN);
    memset (&xMibMsg, 0x00, sizeof(IFX_MIB_MSG_S));

	if (ifx_GetCfgData(FILE_RC_CONF, "vlan_entry_table", "vlan_entry_count",
	                   cRetVal) != 1)
	{
        snmp_log(LOG_ERR, "ifxQosSwEnhanceTable: unable get vlan_entry_count\n");
	}
    nEntryNum = atoi(cRetVal);

    if (nEntryNum > 0)
    {
        xMibMsg.nType = IFX_MIB_QOS_SWENHANCE;
        xMibMsg.nCount = nEntryNum;
        xMibMsg.nPSize = sizeof(QOSSWENHANCECFG_S *);
        xMibMsg.nSize = sizeof(QOSSWENHANCECFG_S);

        ifx_MIB_Dalloc();
	}
}

netsnmp_variable_list *
ifxQosSwEnhanceTable_set_indexes(QOSSWENHANCECFG_S *datainfo,
                                 netsnmp_variable_list *put_index_data)
{
    /* printf("**** ifxQosSwEnhanceTable_set_indexes ****\n"); */
    netsnmp_variable_list   *vptr;

    /* qosSwEnIndex */
    vptr = put_index_data;
    snmp_set_var_value(vptr, (u_char *) &datainfo->index ,
                       sizeof(datainfo->index) );

    return put_index_data;
}

QOSSWENHANCECFG_S  **
ifxQosSwEnhanceTable_get_data(void)
{
    int              i = 0;

    ifxGetQosSwEnhanceCount();

    for ( i = 0; i < nEntryNum; i++)
    {
        pstQosSwEnCfg[i]->index = i;

        memset (&cRetVal, 0x00, MAX_DATA_LEN);
        memset (&cTag, 0x00, MAX_TAG_LEN);
        sprintf (cTag, "vlan_id%d", pstQosSwEnCfg[i]->index);

    	if (ifx_GetCfgData(FILE_RC_CONF, "vlan_entry_table", cTag,
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get nVID\n"));
    	}
        pstQosSwEnCfg[i]->nVID = atoi(cRetVal);

        memset (&cRetVal, 0x00, MAX_DATA_LEN);
        memset (&cTag, 0x00, MAX_TAG_LEN);
        sprintf (cTag, "vlan_acc_lan%d", pstQosSwEnCfg[i]->index);
    
    	if (ifx_GetCfgData(FILE_RC_CONF, "vlan_entry_table", cTag,
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get nAccLAN\n"));
    	}
        pstQosSwEnCfg[i]->nAccLAN = atoi(cRetVal);

        memset (&cRetVal, 0x00, MAX_DATA_LEN);
        memset (&cTag, 0x00, MAX_TAG_LEN);
        sprintf (cTag, "vlan_acc_pc%d", pstQosSwEnCfg[i]->index);
    
    	if (ifx_GetCfgData(FILE_RC_CONF, "vlan_entry_table", cTag,
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get nAccPC\n"));
    	}
        pstQosSwEnCfg[i]->nAccPC = atoi(cRetVal);

        memset (&cRetVal, 0x00, MAX_DATA_LEN);
        memset (&cTag, 0x00, MAX_TAG_LEN);
        sprintf (cTag, "vlan_acc_ipp%d", pstQosSwEnCfg[i]->index);
    
    	if (ifx_GetCfgData(FILE_RC_CONF, "vlan_entry_table", cTag,
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get nAccIPP\n"));
    	}
        pstQosSwEnCfg[i]->nAccIPP = atoi(cRetVal);

        memset (&cRetVal, 0x00, MAX_DATA_LEN);
        memset (&cTag, 0x00, MAX_TAG_LEN);
        sprintf (cTag, "vlan_egr_lan%d", pstQosSwEnCfg[i]->index);
    
    	if (ifx_GetCfgData(FILE_RC_CONF, "vlan_entry_table", cTag,
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get nEgrLAN\n"));
    	}
        pstQosSwEnCfg[i]->nEgrLAN = atoi(cRetVal);

        memset (&cRetVal, 0x00, MAX_DATA_LEN);
        memset (&cTag, 0x00, MAX_TAG_LEN);
        sprintf (cTag, "vlan_egr_pc%d", pstQosSwEnCfg[i]->index);
    
    	if (ifx_GetCfgData(FILE_RC_CONF, "vlan_entry_table", cTag,
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get nEgrPC\n"));
    	}
        pstQosSwEnCfg[i]->nEgrPC = atoi(cRetVal);

        memset (&cRetVal, 0x00, MAX_DATA_LEN);
        memset (&cTag, 0x00, MAX_TAG_LEN);
        sprintf (cTag, "vlan_egr_ipp%d", pstQosSwEnCfg[i]->index);
    
    	if (ifx_GetCfgData(FILE_RC_CONF, "vlan_entry_table", cTag,
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get nEgrIPP\n"));
    	}
        pstQosSwEnCfg[i]->nEgrIPP = atoi(cRetVal);
    }
}

/** returns the first data point within the QOSSWENHANCECFG_S table data.

    Set the my_loop_context variable to the first data point structure
    of your choice (from which you can find the next one).  This could
    be anything from the first node in a linked list, to an integer
    pointer containing the beginning of an array variable.

    Set the my_data_context variable to something to be returned to
    you later that will provide you with the data to return in a given
    row.  This could be the same pointer as what my_loop_context is
    set to, or something different.

    The put_index_data variable contains a list of snmp variable
    bindings, one for each index in your table.  Set the values of
    each appropriately according to the data matching the first row
    and return the put_index_data variable at the end of the function.
*/
netsnmp_variable_list *
ifxQosSwEnhanceTable_get_first_data_point(void **my_loop_context,
                                          void **my_data_context,
                                          netsnmp_variable_list *
                                          put_index_data,
                                          netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxQosSwEnhanceTable_get_first_data_point ****\n"); */
    int     *position;

    /* we could do this with a file-static variable, but for learning
       purposes we'll use memory allocation to demonstrate simplistic
       freeing of a loop_context */
    position = (int *)malloc(sizeof(int));
    if (!position)
        return NULL;

    ifxQosSwEnhanceTable_get_data();

    if (!pstQosSwEnCfg)
    {
        snmp_log(LOG_ERR, "ifxQosSwEnhanceTable: None of row for this table.\n");
        free(position);
        return NULL;
    }

    /* We use the positinonal count as our loop context */
    *position = 0;
    *my_loop_context = position;

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = pstQosSwEnCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxQosSwEnhanceTable_set_indexes(pstQosSwEnCfg[*position], put_index_data);
}

/** functionally the same as ifxQosSwEnhanceTable_get_first_data_point, but
   my_loop_context has already been set to a previous value and should
   be updated to the next in the list.  For example, if it was a
   linked list, you might want to cast it to your local data type and
   then return my_loop_context->next.  The my_data_context pointer
   should be set to something you need later and the indexes in
   put_index_data updated again. */
netsnmp_variable_list *
ifxQosSwEnhanceTable_get_next_data_point(void **my_loop_context,
                                         void **my_data_context,
                                         netsnmp_variable_list *
                                         put_index_data,
                                         netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxQosSwEnhanceTable_get_next_data_point ****\n"); */
    int *position = (int *) *my_loop_context;

    /* make sure we were called correctly */
    if (!position)
        return NULL;
    
    /* go to the next entry in the list */
    (*position)++;

    /* Are we beyond the end? */
    if (*position >= nEntryNum)
    {
        /* End of entry.  stop here by returning NULL */
        free(position);
        ifxGetQosSwEnhanceCount();
        *my_loop_context = NULL;
        *my_data_context = NULL;
        return NULL;
    }

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = pstQosSwEnCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxQosSwEnhanceTable_set_indexes(pstQosSwEnCfg[*position], put_index_data);
}

/** Create a data_context for non-existent rows that SETs are performed on.
 *  return a void * pointer which will be passed to subsequent get_XXX
 *  and set_XXX functions for data retrival and modification during
 *  this SET request.
 *
 *  The indexs are encoded (in order) into the index_data pointer if it
 *  would be helpful to use that information.
 */
void           *
ifxQosSwEnhanceTable_create_data_context(netsnmp_variable_list * index_data,
                                         int column)
{
#ifdef IFX_ADD_ROW
    /* currently, does not support to add/create row dynamicly. */
    /* printf("**** ifxQosSwEnhanceTable_create_data_context ****\n"); */
    pstQosSwEnCfg[nEntryNum] =
        (QOSSWENHANCECFG_S *) malloc(sizeof(QOSSWENHANCECFG_S));

    if (!pstQosSwEnCfg[nEntryNum])
        return NULL;

    memset (pstQosSwEnCfg[nEntryNum], 0x00, sizeof(QOSSWENHANCECFG_S));
    pstQosSwEnCfg[nEntryNum]->index = (int) index_data->val.string;
    
    return pstQosSwEnCfg[nEntryNum];
#else
    return NULL;
#endif
}

/** If the implemented set_* functions don't operate directly on the
   real-live data (which is actually recommended), then this function
   can be used to take a given my_data_context pointer and "commit" it
   to whereever the modified data needs to be put back to.  For
   example, if this was a routing table you could publish the modified
   routes back into the kernel at this point.

   new_or_del will be set to 1 if new, or -1 if it should be deleted
   or 0 if it is just a modification of an existing row.

   If you free the data yourself, make sure to *my_data_context = NULL */
int
ifxQosSwEnhanceTable_commit_row(void **my_data_context, int new_or_del)
{
    QOSSWENHANCECFG_S       *datactx = *my_data_context;
    char                    sBuf[BUF_SIZE_1K];
    char                    sVLANID[MAX_DATA_LEN];
    char                    sAccLANPort[MAX_DATA_LEN];
	char                    sAccPCPort[MAX_DATA_LEN];
    char                    sAccIPPPort[MAX_DATA_LEN];
    char                    sEgressLANPort[MAX_DATA_LEN];
    char                    sEgressPCPort[MAX_DATA_LEN];
    char                    sEgressIPPPort[MAX_DATA_LEN];
    char                    sCount[MAX_DATA_LEN];
    int                     nSetReturn = -1;
    int                     i = 0;

    /* printf("**** ifxQosSwEnhanceTable_commit_row ****\n"); */

    if (new_or_del == -1)
    {
        return SNMP_ERR_NOERROR; /* no change in the value */
    }

    ifxGetQosSwEnhanceCount();

    memset (&sBuf, 0x00, BUF_SIZE_1K);

    for (i = 0; i < nEntryNum; i++)
    {
        memset (&sVLANID, 0x00, MAX_DATA_LEN);
        memset (&sAccLANPort, 0x00, MAX_DATA_LEN);
        memset (&sAccPCPort, 0x00, MAX_DATA_LEN);
        memset (&sAccIPPPort, 0x00, MAX_DATA_LEN);
        memset (&sEgressLANPort, 0x00, MAX_DATA_LEN);
        memset (&sEgressPCPort, 0x00, MAX_DATA_LEN);
        memset (&sEgressIPPPort, 0x00, MAX_DATA_LEN);

        if (i == datactx->index)
        {
            sprintf (sVLANID, "vlan_id%d=\"%d\"\n", i, datactx->nVID);
            strcat (sBuf, sVLANID);
            sprintf (sAccLANPort, "vlan_acc_lan%d=\"%d\"\n", i, datactx->nAccLAN);
            strcat (sBuf, sAccLANPort);
            sprintf (sAccPCPort, "vlan_acc_pc%d=\"%d\"\n", i, datactx->nAccPC);
            strcat (sBuf, sAccPCPort);
            sprintf (sAccIPPPort, "vlan_acc_ipp%d=\"%d\"\n", i, datactx->nAccIPP);
            strcat (sBuf, sAccIPPPort);
            sprintf (sEgressLANPort, "vlan_egr_lan%d=\"%d\"\n", i, datactx->nEgrLAN);
            strcat (sBuf, sEgressLANPort);
            sprintf (sEgressPCPort, "vlan_egr_pc%d=\"%d\"\n", i, datactx->nEgrPC);
            strcat (sBuf, sEgressPCPort);
            sprintf (sEgressIPPPort, "vlan_egr_ipp%d=\"%d\"\n", i, datactx->nEgrIPP);
            strcat (sBuf, sEgressIPPPort);
        }
        else
        {
            memset (&cRetVal, 0x00, MAX_DATA_LEN);
            memset (&cTag, 0x00, MAX_TAG_LEN);
            sprintf (cTag, "vlan_id%d", i);
        	ifx_GetCfgData(FILE_RC_CONF, "vlan_entry_table", cTag, cRetVal);
            sprintf (sVLANID, "%s=\"%s\"\n", cTag, cRetVal);
            strcat (sBuf, sVLANID);

            memset (&cRetVal, 0x00, MAX_DATA_LEN);
            memset (&cTag, 0x00, MAX_TAG_LEN);
            sprintf (cTag, "vlan_acc_lan%d", i);
        	ifx_GetCfgData(FILE_RC_CONF, "vlan_entry_table", cTag, cRetVal);
            sprintf (sAccLANPort, "%s=\"%s\"\n", cTag, cRetVal);
            strcat (sBuf, sAccLANPort);

            memset (&cRetVal, 0x00, MAX_DATA_LEN);
            memset (&cTag, 0x00, MAX_TAG_LEN);
            sprintf (cTag, "vlan_acc_pc%d", i);
        	ifx_GetCfgData(FILE_RC_CONF, "vlan_entry_table", cTag, cRetVal);
            sprintf (sAccPCPort, "%s=\"%s\"\n", cTag, cRetVal);
            strcat (sBuf, sAccPCPort);

            memset (&cRetVal, 0x00, MAX_DATA_LEN);
            memset (&cTag, 0x00, MAX_TAG_LEN);
            sprintf (cTag, "vlan_acc_ipp%d", i);
        	ifx_GetCfgData(FILE_RC_CONF, "vlan_entry_table", cTag, cRetVal);
            sprintf (sAccIPPPort, "%s=\"%s\"\n", cTag, cRetVal);
            strcat (sBuf, sAccIPPPort);

            memset (&cRetVal, 0x00, MAX_DATA_LEN);
            memset (&cTag, 0x00, MAX_TAG_LEN);
            sprintf (cTag, "vlan_egr_lan%d", i);
        	ifx_GetCfgData(FILE_RC_CONF, "vlan_entry_table", cTag, cRetVal);
            sprintf (sEgressLANPort, "%s=\"%s\"\n", cTag, cRetVal);
            strcat (sBuf, sEgressLANPort);

            memset (&cRetVal, 0x00, MAX_DATA_LEN);
            memset (&cTag, 0x00, MAX_TAG_LEN);
            sprintf (cTag, "vlan_egr_pc%d", i);
        	ifx_GetCfgData(FILE_RC_CONF, "vlan_entry_table", cTag, cRetVal);
            sprintf (sEgressPCPort, "%s=\"%s\"\n", cTag, cRetVal);
            strcat (sBuf, sEgressPCPort);

            memset (&cRetVal, 0x00, MAX_DATA_LEN);
            memset (&cTag, 0x00, MAX_TAG_LEN);
            sprintf (cTag, "vlan_egr_ipp%d", i);
            sprintf (sEgressIPPPort, "%s=\"%s\"\n", cTag, cRetVal);
            strcat (sBuf, sEgressIPPPort);
        }
    }

#ifdef IFX_ADD_ROW
    /* currently, does not support to add/create row dynamicly. */
    if (new_or_del == 1)
    {
        memset (&sVLANID, 0x00, MAX_DATA_LEN);
        memset (&sAccLANPort, 0x00, MAX_DATA_LEN);
        memset (&sAccPCPort, 0x00, MAX_DATA_LEN);
        memset (&sAccIPPPort, 0x00, MAX_DATA_LEN);
        memset (&sEgressLANPort, 0x00, MAX_DATA_LEN);
        memset (&sEgressPCPort, 0x00, MAX_DATA_LEN);
        memset (&sEgressIPPPort, 0x00, MAX_DATA_LEN);

        nEntryNum++;
        sprintf (sVLANID, "vlan_id%d=\"%d\"\n", nEntryNum-1,
                 datactx->nVID);
        strcat (sBuf, sVLANID);
        sprintf (sAccLANPort, "vlan_acc_lan%d=\"%d\"\n", nEntryNum-1,
                 datactx->nAccLAN);
        strcat (sBuf, sAccLANPort);
        sprintf (sAccPCPort, "vlan_acc_pc%d=\"%d\"\n", nEntryNum-1,
                 datactx->nAccPC);
        strcat (sBuf, sAccPCPort);
        sprintf (sAccIPPPort, "vlan_acc_ipp%d=\"%d\"\n", nEntryNum-1,
                 datactx->nAccIPP);
        strcat (sBuf, sAccIPPPort);
        sprintf (sEgressLANPort, "vlan_egr_lan%d=\"%d\"\n", nEntryNum-1,
                 datactx->nEgrLAN);
        strcat (sBuf, sEgressLANPort);
        sprintf (sEgressPCPort, "vlan_egr_pc%d=\"%d\"\n", nEntryNum-1,
                 datactx->nEgrPC);
        strcat (sBuf, sEgressPCPort);
        sprintf (sEgressIPPPort, "vlan_egr_ipp%d=\"%d\"\n", nEntryNum-1,
                 datactx->nEgrIPP);
        strcat (sBuf, sEgressIPPPort);
    }
#endif

    sprintf (sCount, "vlan_entry_count=\"%d\"\n", nEntryNum);
    strcat (sBuf, sCount);

    nSetReturn = websSetCfgData(FILE_RC_CONF, "vlan_entry_table", 1, sBuf);

    if (nSetReturn != 1)
    {
        return SNMP_ERR_COMMITFAILED;
    }

#ifdef IFX_ADD_ROW
    /* currently, does not support to add/create row dynamicly. */
    if (new_or_del == 1)
    {
        if (pstQosSwEnCfg[nEntryNum-1])
        {
            free(pstQosSwEnCfg[nEntryNum-1]);
            pstQosSwEnCfg[nEntryNum-1] = NULL;
        }
    }
#endif

    /*
     * return no errors.  And there shouldn't be any!!!  Ever!!!  You
     * should have checked the values long before this. 
     */
    return SNMP_ERR_NOERROR;
}

/*
 * User-defined data access functions (per column) for data in table ifxQosSwEnhanceTable 
 */
/*
 * NOTE:
 * - these get_ routines MUST return data that will not be freed (ie,
 *   use static variables or persistent data).  It will be copied, if
 *   needed, immediately after the get_ routine has been called.
 * - these SET routines must copy the incoming data and can not take
 *   ownership of the memory passed in by the val pointer.
 */
/** XXX: return a data pointer to the data for the qosVID column and set
         ret_len to its proper size in bytes. */
int           *
get_qosVID(void *data_context, size_t * ret_len)
{
    QOSSWENHANCECFG_S *datainfo = data_context;
    *ret_len = sizeof(datainfo->nVID);
    return &datainfo->nVID;
}

/** XXX: Set the value of the qosVID column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_qosVID(void *data_context, int *val, size_t val_len)
{
    QOSSWENHANCECFG_S *datainfo = data_context;
    memcpy(&datainfo->nVID, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the qosAccLAN column and set
         ret_len to its proper size in bytes. */
int           *
get_qosAccLAN(void *data_context, size_t * ret_len)
{
    QOSSWENHANCECFG_S *datainfo = data_context;
    *ret_len = sizeof(datainfo->nAccLAN);
    return &datainfo->nAccLAN;
}

/** XXX: Set the value of the qosAccLAN column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_qosAccLAN(void *data_context, int *val, size_t val_len)
{
    QOSSWENHANCECFG_S *datainfo = data_context;
    memcpy(&datainfo->nAccLAN, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the qosAccPC column and set
         ret_len to its proper size in bytes. */
int           *
get_qosAccPC(void *data_context, size_t * ret_len)
{
    QOSSWENHANCECFG_S *datainfo = data_context;
    *ret_len = sizeof(datainfo->nAccPC);
    return &datainfo->nAccPC;
}

/** XXX: Set the value of the qosAccPC column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_qosAccPC(void *data_context, int *val, size_t val_len)
{
    QOSSWENHANCECFG_S *datainfo = data_context;
    memcpy(&datainfo->nAccPC, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the qosAccIPP column and set
         ret_len to its proper size in bytes. */
int           *
get_qosAccIPP(void *data_context, size_t * ret_len)
{
    QOSSWENHANCECFG_S *datainfo = data_context;
    *ret_len = sizeof(datainfo->nAccIPP);
    return &datainfo->nAccIPP;
}

/** XXX: Set the value of the qosAccIPP column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_qosAccIPP(void *data_context, int *val, size_t val_len)
{
    QOSSWENHANCECFG_S *datainfo = data_context;
    memcpy(&datainfo->nAccIPP, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the qosEgrLAN column and set
         ret_len to its proper size in bytes. */
int           *
get_qosEgrLAN(void *data_context, size_t * ret_len)
{
    QOSSWENHANCECFG_S *datainfo = data_context;
    *ret_len = sizeof(datainfo->nEgrLAN);
    return &datainfo->nEgrLAN;
}

/** XXX: Set the value of the qosEgrLAN column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_qosEgrLAN(void *data_context, int *val, size_t val_len)
{
    QOSSWENHANCECFG_S *datainfo = data_context;
    memcpy(&datainfo->nEgrLAN, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the qosEgrPC column and set
         ret_len to its proper size in bytes. */
int           *
get_qosEgrPC(void *data_context, size_t * ret_len)
{
    QOSSWENHANCECFG_S *datainfo = data_context;
    *ret_len = sizeof(datainfo->nEgrPC);
    return &datainfo->nEgrPC;
}

/** XXX: Set the value of the qosEgrPC column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_qosEgrPC(void *data_context, int *val, size_t val_len)
{
    QOSSWENHANCECFG_S *datainfo = data_context;
    memcpy(&datainfo->nEgrPC, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the qosEgrIPP column and set
         ret_len to its proper size in bytes. */
int           *
get_qosEgrIPP(void *data_context, size_t * ret_len)
{
    QOSSWENHANCECFG_S *datainfo = data_context;
    *ret_len = sizeof(datainfo->nEgrIPP);
    return &datainfo->nEgrIPP;
}

/** XXX: Set the value of the qosEgrIPP column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_qosEgrIPP(void *data_context, int *val, size_t val_len)
{
    QOSSWENHANCECFG_S *datainfo = data_context;
    memcpy(&datainfo->nEgrIPP, val, val_len);
    return SNMP_ERR_NOERROR;
}
