/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : RTP MIB
 *        Creator : Sharon Tseng
 *        File    : rtpRcvrTable.c
 *        Abstract: 
 *                  
 *        Date    : 12-May-2005
 *        Ref. Doc: RFC 2959
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.iterate_access.conf,v 1.6 2003/09/29 22:30:36 hardaker Exp $
 */
/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
*/
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "rtpRcvrTable.h"

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
 */
/** Initialize the rtpRcvrTable table by defining its contents and how it's structured */
void
initialize_table_rtpRcvrTable(void)
{
    static oid      rtpRcvrTable_oid[] = { 1, 3, 6, 1, 2, 1, 87, 1, 7 };
    netsnmp_table_registration_info *table_info;
    netsnmp_handler_registration *my_handler;
    netsnmp_iterator_info *iinfo;

    /** create the table registration information structures */
    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);

    my_handler = netsnmp_create_handler_registration("rtpRcvrTable",
                                                     rtpRcvrTable_handler,
                                                     rtpRcvrTable_oid,
                                                     OID_LENGTH
                                                     (rtpRcvrTable_oid),
                                                     HANDLER_CAN_RONLY);

    if (!my_handler || !table_info || !iinfo)
    {

#ifdef IIP_MEM_LEAK_FIX
         if (my_handler)
            SNMP_FREE(my_handler);
         if (table_info)
            SNMP_FREE(table_info);
          if (iinfo)
            SNMP_FREE(iinfo);
#endif
        snmp_log(LOG_ERR,\
                 "malloc failed in initialize_table_rtpRcvrTable");
        return; /** Serious error. */
    }

    /***************************************************
     * Setting up the table's definition
     */
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,             /** index: rtpSessionIndex */
                                     ASN_UNSIGNED,                        /** index: rtpRcvrSRCSSRC */
                                     ASN_UNSIGNED,                        /** index: rtpRcvrSSRC */
                                     0);

    /** Define the minimum and maximum accessible columns.  This
        optimizes retrival. */
    table_info->min_column = 3;
    table_info->max_column = 14;

    /** iterator access routines */
    iinfo->get_first_data_point = rtpRcvrTable_get_first_data_point;
    iinfo->get_next_data_point = rtpRcvrTable_get_next_data_point;

    /** you may wish to set these as well */
#ifdef MAYBE_USE_THESE
    iinfo->make_data_context = rtpRcvrTable_context_convert_function;
    iinfo->free_data_context = rtpRcvrTable_data_free;

    /** pick *only* one of these if you use them */
    iinfo->free_loop_context = rtpRcvrTable_loop_free;
    iinfo->free_loop_context_at_end = rtpRcvrTable_loop_free;
#endif

    /** tie the two structures together */
    iinfo->table_reginfo = table_info;

    /***************************************************
     * registering the table with the master agent
     */
    DEBUGMSGTL(("initialize_table_rtpRcvrTable",
                "Registering table rtpRcvrTable as a table iterator\n"));
    netsnmp_register_table_iterator(my_handler, iinfo);
}

/** Initializes the rtpRcvrTable module */
void
init_rtpRcvrTable(void)
{
    /** here we initialize all the tables we're planning on supporting */
    initialize_table_rtpRcvrTable();
}

/** handles requests for the rtpRcvrTable table, if anything else needs to be done */
int
rtpRcvrTable_handler(netsnmp_mib_handler *handler,
                     netsnmp_handler_registration *reginfo,
                     netsnmp_agent_request_info *reqinfo,
                     netsnmp_request_info *requests)
{
    netsnmp_request_info        *request;
    netsnmp_table_request_info  *table_info;
    netsnmp_variable_list       *var;
    void                        *data_context = NULL;
    oid                         *suffix;
    size_t                      suffix_len;

    for (request = requests; request != NULL; request = request->next)
    {
        /** column and row index encoded portion */
        var = request->requestvb;
        suffix = var->name + reginfo->rootoid_len + 1;
        suffix_len = var->name_length - (reginfo->rootoid_len + 1);
        if (request->processed != 0)
            continue;

        switch (reqinfo->mode)
        {
        case MODE_GET:
            data_context = netsnmp_extract_iterator_context(request);
	            if (data_context == NULL)
	            {
	                if (reqinfo->mode == MODE_GET)
	                {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
            }
            break;

        default:
            break;

        }

        /** extracts the information about the table from the request */
        table_info = netsnmp_extract_table_info(request);
        /** table_info->colnum contains the column number requested */
        /** table_info->indexes contains a linked list of snmp variable
           bindings for the indexes of the table.  Values in the list
           have been set corresponding to the indexes of the
           request */
        if (table_info == NULL)
        {
            continue;
        }

        switch (reqinfo->mode)
        {
        case MODE_GET:
	            switch (table_info->colnum)
	            {
            case COLUMN_RTPRCVRCNAME:
                {
                    char          *retval;
                    size_t          retval_len = 0;
                    retval = get_rtpRcvrCNAME(data_context, &retval_len);
                    snmp_set_var_typed_value(var,ASN_OCTET_STR,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_RTPRCVRADDR:
                {
                    unsigned char   *retval;
                    size_t          retval_len = 0;
                    retval = get_rtpRcvrAddr(data_context, &retval_len);
                    snmp_set_var_typed_value(var, ASN_OCTET_STR,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_RTPRCVRRTT:
                {
                    unsigned int    *retval;
                    size_t          retval_len = 0;
                    retval = get_rtpRcvrRTT(data_context, &retval_len);
                    snmp_set_var_typed_value(var, ASN_GAUGE,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_RTPRCVRLOSTPACKETS:
                {
                    uint64          *retval;
                    size_t          retval_len = 0;
                    retval =
                        get_rtpRcvrLostPackets(data_context, &retval_len);
                    snmp_set_var_typed_value(var, ASN_COUNTER64,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_RTPRCVRJITTER:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    retval = get_rtpRcvrJitter(data_context, &retval_len);
                    snmp_set_var_typed_value(var, ASN_GAUGE,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_RTPRCVRTOOL:
                {
                    char            *retval;
                    size_t          retval_len = 0;
                    retval = get_rtpRcvrTool(data_context, &retval_len);
                    snmp_set_var_typed_value(var,ASN_OCTET_STR,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_RTPRCVRRRS:
                {
                    unsigned int    *retval;
                    size_t          retval_len = 0;
                    retval = get_rtpRcvrRRs(data_context, &retval_len);
                    snmp_set_var_typed_value(var, ASN_COUNTER,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_RTPRCVRRRTIME:
                {
                    unsigned int    *retval;
                    size_t          retval_len = 0;
                    retval = get_rtpRcvrRRTime(data_context, &retval_len);
                    snmp_set_var_typed_value(var, ASN_TIMETICKS,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_RTPRCVRPT:
                {
                    int             *retval;
                    size_t          retval_len = 0;
                    retval = get_rtpRcvrPT(data_context, &retval_len);
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_RTPRCVRPACKETS:
                {
                    uint64          *retval;
                    size_t          retval_len = 0;
                    retval = get_rtpRcvrPackets(data_context, &retval_len);
                    snmp_set_var_typed_value(var, ASN_COUNTER64,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_RTPRCVROCTETS:
                {
                    uint64          *retval;
                    size_t          retval_len = 0;
                    retval = get_rtpRcvrOctets(data_context, &retval_len);
                    snmp_set_var_typed_value(var, ASN_COUNTER64,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_RTPRCVRSTARTTIME:
                {
                    unsigned int    *retval;
                    size_t          retval_len = 0;
                    retval =
                        get_rtpRcvrStartTime(data_context, &retval_len);
                    snmp_set_var_typed_value(var, ASN_TIMETICKS,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            default:
                /** We shouldn't get here */
                snmp_log(LOG_ERR,
                         "problem encountered in rtpRcvrTable_handler: unknown column\n");
            }
            break;
        default:
            snmp_log(LOG_ERR,
                     "problem encountered in rtpRcvrTable_handler: unsupported mode\n");
        }
    }

    return SNMP_ERR_NOERROR;
}
