/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : RTP MIB
 *        Creator : Sharon Tseng
 *        File    : rtpSessionTable_checkfns.c
 *        Abstract: 
 *                  
 *        Date    : 12-May-2005
 *        Ref. Doc: RFC 2959
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.check_values.conf,v 1.6 2003/06/13 18:18:04 hardaker Exp $
 */

/********************************************************************
 *                       NOTE   NOTE   NOTE
 *   This file is auto-generated and SHOULD NOT BE EDITED by hand.
 *   Modify the rtpSessionTable_checkfns_local.[ch] files insead so that you
 *   can regenerate this one as mib2c improvements are made.
 ********************************************************************/

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
 */
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <ifxCommon/ifxMIB_common.h>
#include "rtpSessionTable_checkfns.h"
#include "rtpSessionTable_checkfns_local.h"

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
 */
/** Decides if an incoming value for the rtpSessionDomain mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_rtpSessionDomain(int type, oid * val, size_t val_len,
                       oid * old_val, size_t old_val_len)
{

    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_OBJECT_ID)
        return SNMP_ERR_WRONGTYPE;

    /** looks ok, call the local version of the same function. */
    return check_rtpSessionDomain_local(type, val, val_len, old_val,
                                        old_val_len);
}

/** Decides if an incoming value for the rtpSessionRemAddr mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_rtpSessionRemAddr(int type, char *val, size_t val_len,
                        char *old_val, size_t old_val_len)
{

    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_OCTET_STR)
        return SNMP_ERR_WRONGTYPE;

    /** looks ok, call the local version of the same function. */
    return check_rtpSessionRemAddr_local(type, val, val_len, old_val,
                                         old_val_len);
}

/** Decides if an incoming value for the rtpSessionIfIndex mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_rtpSessionIfIndex(int type, long *val, size_t val_len,
                        long *old_val, size_t old_val_len)
{

    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    ret = SNMP_ERR_NOERROR;
    /** Check the ranges of the passed value for legality */
    if (!(*val >= 1 && *val <= 2147483647))
        return SNMP_ERR_WRONGVALUE;

    /** looks ok, call the local version of the same function. */
        return check_rtpSessionIfIndex_local(type, val, val_len, old_val,
                                             old_val_len);
}

/** Decides if an incoming value for the rtpSessionRowStatus mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_rtpSessionRowStatus(int type, long *val, size_t val_len,
                          long *old_val, size_t old_val_len)
{

        int ret;
    /** Check to see that we were called legally */
        if (!val)
        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
        if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;
    /** Check the enums.  Legal values will continue, others return error. */
        switch (*val) {
case ROWSTATUS_ACTIVE:
case ROWSTATUS_NOTINSERVICE:
case ROWSTATUS_NOTREADY:
case ROWSTATUS_CREATEANDGO:
case ROWSTATUS_CREATEANDWAIT:
case ROWSTATUS_DESTROY:
        break;
    /** not a legal enum value.  return an error */
default:
        return SNMP_ERR_INCONSISTENTVALUE;}
        ret = SNMP_ERR_NOERROR;
        if (ret =
            check_rowstatus_transition((old_val) ? *old_val :
                                       RS_NONEXISTENT, *val))
        return ret;
    /** looks ok, call the local version of the same function. */
        return check_rtpSessionRowStatus_local(type, val, val_len, old_val,
                                               old_val_len);
}

