#!/bin/sh

#
#Portions of this file are subject to the following copyright(s).  See
#the Net-SNMP's COPYING file for more details and other copyrights
#that may apply:
#

TOPDIR=`pwd`/../../../../
. ${TOPDIR}tools/build_tools/Path.sh

APPS_NAME="snmp-5.2.1"
echo "PATH : "$PATH

echo "TARGET : "$OPERA_TARGET$OPERA_TARGET_VER

echo "----------------------------------------------------------------------"
echo "----------------------- Build net snmp-5.2.1 -------------------------"
echo "----------------------------------------------------------------------"
# Hardcoded config param
IFX_CONFIG_SNMPv1="1"
IFX_CONFIG_INCAIP2="1"

parse_args $@


if [ $IFX_CONFIG_INCAIP2 -eq 1 ]; then
	PRODUCT=IIP
else
	PRODUCT=$PRODUCT
fi

if [ "$PRODUCT" == "" ]; then
   echo "Error : Export/Set PRODUCT and run the script again...."
   exit
fi

if [ $BUILD_CLEAN -eq 1 ]; then
	rm -rf .config_ok
	rm -f ${BUILD_ROOTFS_DIR}usr/lib/libnetsnmp*
	rm -f ${BUILD_ROOTFS_DIR}usr/sbin/snmp*
	make distclean
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi
BUILD_2MB_PACKAGE=0
export IFX_LDFLAGS="-L$PWD/opera/mips_R3/usr/lib/" 
#export IFX_CFLAGS TARGET HOST BUILD IFX_LDFLAGS
if [ "$1" = "config_only" -a ! -f .config_ok -o $BUILD_CONFIGURE -eq 1 ]; then
	echo "configure"
	#make distclean
	if [ "$BUILD_2MB_PACKAGE" = "1" ]; then
		echo "2MB pkg"
		cp -f configure_2MB_pkg current_configuration
		cp -f configure_2MB configure
		cp -f Makefile.rules.2MB_pkg Makefile.rules
	elif [ "$IFX_CONFIG_SNMPv1" = "1" ]; then
		echo "snmpv1"
		cp -f configure_snmpv1_pkg current_configuration
		cp -f configure_full configure
		cp -f Makefile.rules.full Makefile.rules
	elif [ "$IFX_CONFIG_SNMPv3" = "1" ]; then
		echo "snmpv3"
		if [ $IFX_CONFIG_INCAIP2 -eq 1 ]; then
			echo incaip
			cp -f configure_incaip_pkg current_configuration
		else
			cp -f configure_snmpv3_pkg current_configuration
		fi
		cp -f configure_full configure
		cp -f Makefile.rules.full Makefile.rules
	fi
		chmod a+x current_configuration
		echo "BUILD_ROOTFS_DIR is ${BUILD_ROOTFS_DIR}"
		AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC}  RANLIB=${IFX_RANLIB} BUILDCC=${IFX_HOSTCC} CXX=${IFX_CXX} OBJCOPY=${IFX_OBJCOPY} OBJDUMP=${IFX_OBJDUMP} IFX_CFLAGS={IFX_CFLAGS} IFX_LDFLAGS={IFX_LDFLAGS} TARGET=${TARGET} HOST=${HOST} BUILD=${BUILD} BUILD_ROOTFS_DIR=${BUILD_ROOTFS_DIR} ./current_configuration

	ifx_error_check $? 
	echo -n > .config_ok
	cp -f include/net-snmp/net-snmp-config.h acconfig.h -f
fi

if [ "$1" = "config_only" ] ;then
	exit 0
fi

if [ "$BUILD_2MB_PACKAGE" = "1" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DHAVE_MINIMAL_HELPERS -DHAVE_MINIMAL_LIBSUPPORT -DHAVE_OPTIMIZED_CODE " 
elif [ "$IFX_CONFIG_SNMPv1" = "1" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DILMI -DHAVE_CACHE_SUPPORT "
elif [ "$IFX_CONFIG_SNMPv3" = "1" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DHAVE_CACHE_SUPPORT -DSNMP_SECMOD_USM -D${PRODUCT} -DSRTP -DIFX_GET_INTERFACE -DIFX_ADD_ROW " #-DIFX_RTP_WRITABLE"
fi

make IFX_CFLAGS="${IFX_CFLAGS}" IFX_LDFLAGS="${IFX_LDFLAGS}" all 
ifx_error_check $? 

make -C agent install  IFX_CFLAGS="${IFX_CFLAGS}" IFX_LDFLAGS="${IFX_LDFLAGS}"  
ifx_error_check $? 

${IFX_STRIP} -R.note -R.comment ${BUILD_ROOTFS_DIR}usr/sbin/snmp*

if [ "$BUILD_2MB_PACKAGE" != "1" ]; then
	make -C snmplib install IFX_CFLAGS="${IFX_CFLAGS}" IFX_LDFLAGS="${IFX_LDFLAGS}" 
	ifx_error_check $?
	rm -f ${BUILD_ROOTFS_DIR}usr/lib/libnetsnmp*.a
	rm -f ${BUILD_ROOTFS_DIR}usr/lib/libnetsnmp*.la
	${IFX_STRIP} --strip-unneeded ${BUILD_ROOTFS_DIR}usr/lib/libnetsnmp*
fi

cp -fv agent/helpers/.libs/libnetsnmphelpers.so opera/$OPERA_TARGET$OPERA_TARGET_VER/usr/lib
cp -fv agent/.libs/libnetsnmpagent.so opera/$OPERA_TARGET$OPERA_TARGET_VER/usr/lib
cp -fv agent/.libs/libnetsnmpmibs.so opera/$OPERA_TARGET$OPERA_TARGET_VER/usr/lib
cp -fv snmplib/.libs/libnetsnmp.so opera/$OPERA_TARGET$OPERA_TARGET_VER/usr/lib
cp -fv agent/.libs/snmpd opera/$OPERA_TARGET$OPERA_TARGET_VER/usr/sbin
cd opera/$OPERA_TARGET$OPERA_TARGET_VER
tar cvzf ../../../PreBuilt/$OPERA_TARGET$OPERA_TARGET_VER/WP_COM/snmp.tgz ./usr
